/*! @name @ptv.js/videojs-ptv @version 1.5.0 @license MIT */
(function (QUnit, videojs, sinon) {
	'use strict';

	function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

	var QUnit__default = /*#__PURE__*/_interopDefaultLegacy(QUnit);
	var videojs__default = /*#__PURE__*/_interopDefaultLegacy(videojs);
	var sinon__default = /*#__PURE__*/_interopDefaultLegacy(sinon);

	var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

	function createCommonjsModule(fn, basedir, module) {
		return module = {
		  path: basedir,
		  exports: {},
		  require: function (path, base) {
	      return commonjsRequire(path, (base === undefined || base === null) ? module.path : base);
	    }
		}, fn(module, module.exports), module.exports;
	}

	function getCjsExportFromNamespace (n) {
		return n && n['default'] || n;
	}

	function commonjsRequire () {
		throw new Error('Dynamic requires are not currently supported by @rollup/plugin-commonjs');
	}

	var _nodeResolve_empty = {};

	var _nodeResolve_empty$1 = /*#__PURE__*/Object.freeze({
		__proto__: null,
		'default': _nodeResolve_empty
	});

	var minDoc = getCjsExportFromNamespace(_nodeResolve_empty$1);

	var topLevel = typeof commonjsGlobal !== 'undefined' ? commonjsGlobal : typeof window !== 'undefined' ? window : {};
	var doccy;

	if (typeof document !== 'undefined') {
	  doccy = document;
	} else {
	  doccy = topLevel['__GLOBAL_DOCUMENT_CACHE@4'];

	  if (!doccy) {
	    doccy = topLevel['__GLOBAL_DOCUMENT_CACHE@4'] = minDoc;
	  }
	}

	var document_1 = doccy;

	var win;

	if (typeof window !== "undefined") {
	  win = window;
	} else if (typeof commonjsGlobal !== "undefined") {
	  win = commonjsGlobal;
	} else if (typeof self !== "undefined") {
	  win = self;
	} else {
	  win = {};
	}

	var window_1 = win;

	var cov_2eia7r2cpc = function () {
	  var path = '/home/runner/work/videojs-ptv/videojs-ptv/src/constants.js',
	      hash = 'd98ed74337411b75ed4c74b1c8604c5ed5c4a75d',
	      Function = function () {}.constructor,
	      global = new Function('return this')(),
	      gcv = '__coverage__',
	      coverageData = {
	    path: '/home/runner/work/videojs-ptv/videojs-ptv/src/constants.js',
	    statementMap: {
	      '0': {
	        start: {
	          line: 6,
	          column: 24
	        },
	        end: {
	          line: 11,
	          column: 2
	        }
	      },
	      '1': {
	        start: {
	          line: 18,
	          column: 26
	        },
	        end: {
	          line: 23,
	          column: 2
	        }
	      },
	      '2': {
	        start: {
	          line: 30,
	          column: 29
	        },
	        end: {
	          line: 32,
	          column: 2
	        }
	      },
	      '3': {
	        start: {
	          line: 39,
	          column: 29
	        },
	        end: {
	          line: 41,
	          column: 2
	        }
	      },
	      '4': {
	        start: {
	          line: 48,
	          column: 28
	        },
	        end: {
	          line: 55,
	          column: 2
	        }
	      },
	      '5': {
	        start: {
	          line: 62,
	          column: 25
	        },
	        end: {
	          line: 66,
	          column: 2
	        }
	      }
	    },
	    fnMap: {},
	    branchMap: {},
	    s: {
	      '0': 0,
	      '1': 0,
	      '2': 0,
	      '3': 0,
	      '4': 0,
	      '5': 0
	    },
	    f: {},
	    b: {},
	    _coverageSchema: '332fd63041d2c1bcb487cc26dd0d5f7d97098a6c'
	  },
	      coverage = global[gcv] || (global[gcv] = {});

	  if (coverage[path] && coverage[path].hash === hash) {
	    return coverage[path];
	  }

	  coverageData.hash = hash;
	  return coverage[path] = coverageData;
	}();

	var ApiHosts = (cov_2eia7r2cpc.s[0]++, Object.freeze({
	  COMDEV: 'comdev',
	  QA: 'qa',
	  STAGING: 'staging',
	  PRODUCTION: 'prod'
	}));
	var EmbedHosts = (cov_2eia7r2cpc.s[1]++, Object.freeze({
	  COMDEV: 'comdev.embed.promethean.tv',
	  QA: 'qa.embed.promethean.tv',
	  STAGING: 'staging.embed.promethean.tv',
	  PRODUCTION: 'embed.promethean.tv'
	}));
	var PlatformNames = (cov_2eia7r2cpc.s[2]++, Object.freeze({
	  TRUE: 'truetv'
	}));
	var PlatformTypes = (cov_2eia7r2cpc.s[3]++, Object.freeze({
	  CMS_ID: 'cmsid'
	}));
	var PlayerEvents = (cov_2eia7r2cpc.s[4]++, Object.freeze({
	  ENDED: 'ended',
	  ERROR: 'error',
	  PAUSE: 'pause',
	  PLAY: 'play',
	  PLAYING: 'playing',
	  TIME_UPDATE: 'timeupdate'
	}));
	var SdkEvents = (cov_2eia7r2cpc.s[5]++, Object.freeze({
	  CLICK_MISS: 'ptv.click.miss',
	  CONFIG_FAILURE: 'ptv.config.failure',
	  CONFIG_READY: 'ptv.config.ready'
	}));

	var PTV_TEST_CALLBACK = 'ptv_test_callback';
	/**
	 * This markup is injected directly into the Iframe via `srcdoc` and allows us
	 * to verify messages sent via `postMessage`.
	 *
	 * The target (html page below) listens for messages sent by the videojs-ptv
	 * plugin and echoes any received messages back to the host window via a
	 * function defined at `window[PTV_TEST_CALLBACK]`
	 *
	 * Tests can dynamically assign functions to window[PTV_TEST_CALLBACK] allowing
	 * assertions to be made about payloads received by the target window.
	 *
	 * @type {string}
	 */

	var iframeMarkup = "<!DOCTYPE html>\n<html>\n<head>\n<script>\nconsole.log('setting up iframe test target');\nwindow.addEventListener('message', evt => {\n  console.log('iframe test target received', evt);\n  // evt.source provides a reference to the host page's Window\n  if (typeof evt.source['" + PTV_TEST_CALLBACK + "'] === 'function') {\n    console.log('sending to ptv_test_callback');\n    evt.source['" + PTV_TEST_CALLBACK + "'](evt.data);\n  }\n});\n</script>\n</head>\n<body>\n<script>\nif (window.parent) {\n  console.log('iframe test target sending CONFIG_READY');\n  const msg = JSON.stringify({ type: \"" + SdkEvents.CONFIG_READY + "\", data: {} });\n  window.parent.postMessage(msg, '*')\n}\n</script>\n</body>\n</html>\n";

	function _defineProperties(target, props) {
	  for (var i = 0; i < props.length; i++) {
	    var descriptor = props[i];
	    descriptor.enumerable = descriptor.enumerable || false;
	    descriptor.configurable = true;
	    if ("value" in descriptor) descriptor.writable = true;
	    Object.defineProperty(target, descriptor.key, descriptor);
	  }
	}

	function _createClass(Constructor, protoProps, staticProps) {
	  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
	  if (staticProps) _defineProperties(Constructor, staticProps);
	  return Constructor;
	}

	var createClass = _createClass;

	var cov_ambywxk92 = function () {
	  var path = '/home/runner/work/videojs-ptv/videojs-ptv/src/postmessage.js',
	      hash = '59b7266ee0890f7627bfa016017ae8125de26fad',
	      Function = function () {}.constructor,
	      global = new Function('return this')(),
	      gcv = '__coverage__',
	      coverageData = {
	    path: '/home/runner/work/videojs-ptv/videojs-ptv/src/postmessage.js',
	    statementMap: {
	      '0': {
	        start: {
	          line: 7,
	          column: 15
	        },
	        end: {
	          line: 7,
	          column: 26
	        }
	      },
	      '1': {
	        start: {
	          line: 16,
	          column: 2
	        },
	        end: {
	          line: 22,
	          column: 3
	        }
	      },
	      '2': {
	        start: {
	          line: 17,
	          column: 4
	        },
	        end: {
	          line: 21,
	          column: 5
	        }
	      },
	      '3': {
	        start: {
	          line: 18,
	          column: 6
	        },
	        end: {
	          line: 18,
	          column: 30
	        }
	      },
	      '4': {
	        start: {
	          line: 20,
	          column: 6
	        },
	        end: {
	          line: 20,
	          column: 16
	        }
	      },
	      '5': {
	        start: {
	          line: 24,
	          column: 2
	        },
	        end: {
	          line: 24,
	          column: 14
	        }
	      },
	      '6': {
	        start: {
	          line: 36,
	          column: 2
	        },
	        end: {
	          line: 43,
	          column: 3
	        }
	      },
	      '7': {
	        start: {
	          line: 42,
	          column: 4
	        },
	        end: {
	          line: 42,
	          column: 11
	        }
	      },
	      '8': {
	        start: {
	          line: 45,
	          column: 16
	        },
	        end: {
	          line: 45,
	          column: 34
	        }
	      },
	      '9': {
	        start: {
	          line: 47,
	          column: 2
	        },
	        end: {
	          line: 49,
	          column: 3
	        }
	      },
	      '10': {
	        start: {
	          line: 48,
	          column: 4
	        },
	        end: {
	          line: 48,
	          column: 27
	        }
	      },
	      '11': {
	        start: {
	          line: 52,
	          column: 20
	        },
	        end: {
	          line: 52,
	          column: 106
	        }
	      },
	      '12': {
	        start: {
	          line: 54,
	          column: 2
	        },
	        end: {
	          line: 56,
	          column: 3
	        }
	      },
	      '13': {
	        start: {
	          line: 55,
	          column: 4
	        },
	        end: {
	          line: 55,
	          column: 38
	        }
	      },
	      '14': {
	        start: {
	          line: 58,
	          column: 2
	        },
	        end: {
	          line: 58,
	          column: 62
	        }
	      }
	    },
	    fnMap: {
	      '0': {
	        name: 'parseMessageData',
	        decl: {
	          start: {
	            line: 15,
	            column: 16
	          },
	          end: {
	            line: 15,
	            column: 32
	          }
	        },
	        loc: {
	          start: {
	            line: 15,
	            column: 39
	          },
	          end: {
	            line: 25,
	            column: 1
	          }
	        },
	        line: 15
	      },
	      '1': {
	        name: 'postMessage',
	        decl: {
	          start: {
	            line: 35,
	            column: 16
	          },
	          end: {
	            line: 35,
	            column: 27
	          }
	        },
	        loc: {
	          start: {
	            line: 35,
	            column: 52
	          },
	          end: {
	            line: 59,
	            column: 1
	          }
	        },
	        line: 35
	      }
	    },
	    branchMap: {
	      '0': {
	        loc: {
	          start: {
	            line: 16,
	            column: 2
	          },
	          end: {
	            line: 22,
	            column: 3
	          }
	        },
	        type: 'if',
	        locations: [{
	          start: {
	            line: 16,
	            column: 2
	          },
	          end: {
	            line: 22,
	            column: 3
	          }
	        }, {
	          start: {
	            line: 16,
	            column: 2
	          },
	          end: {
	            line: 22,
	            column: 3
	          }
	        }],
	        line: 16
	      },
	      '1': {
	        loc: {
	          start: {
	            line: 36,
	            column: 2
	          },
	          end: {
	            line: 43,
	            column: 3
	          }
	        },
	        type: 'if',
	        locations: [{
	          start: {
	            line: 36,
	            column: 2
	          },
	          end: {
	            line: 43,
	            column: 3
	          }
	        }, {
	          start: {
	            line: 36,
	            column: 2
	          },
	          end: {
	            line: 43,
	            column: 3
	          }
	        }],
	        line: 36
	      },
	      '2': {
	        loc: {
	          start: {
	            line: 37,
	            column: 4
	          },
	          end: {
	            line: 40,
	            column: 40
	          }
	        },
	        type: 'binary-expr',
	        locations: [{
	          start: {
	            line: 37,
	            column: 4
	          },
	          end: {
	            line: 37,
	            column: 11
	          }
	        }, {
	          start: {
	            line: 38,
	            column: 4
	          },
	          end: {
	            line: 38,
	            column: 14
	          }
	        }, {
	          start: {
	            line: 39,
	            column: 4
	          },
	          end: {
	            line: 39,
	            column: 28
	          }
	        }, {
	          start: {
	            line: 40,
	            column: 4
	          },
	          end: {
	            line: 40,
	            column: 40
	          }
	        }],
	        line: 37
	      },
	      '3': {
	        loc: {
	          start: {
	            line: 47,
	            column: 2
	          },
	          end: {
	            line: 49,
	            column: 3
	          }
	        },
	        type: 'if',
	        locations: [{
	          start: {
	            line: 47,
	            column: 2
	          },
	          end: {
	            line: 49,
	            column: 3
	          }
	        }, {
	          start: {
	            line: 47,
	            column: 2
	          },
	          end: {
	            line: 49,
	            column: 3
	          }
	        }],
	        line: 47
	      },
	      '4': {
	        loc: {
	          start: {
	            line: 54,
	            column: 2
	          },
	          end: {
	            line: 56,
	            column: 3
	          }
	        },
	        type: 'if',
	        locations: [{
	          start: {
	            line: 54,
	            column: 2
	          },
	          end: {
	            line: 56,
	            column: 3
	          }
	        }, {
	          start: {
	            line: 54,
	            column: 2
	          },
	          end: {
	            line: 56,
	            column: 3
	          }
	        }],
	        line: 54
	      },
	      '5': {
	        loc: {
	          start: {
	            line: 54,
	            column: 6
	          },
	          end: {
	            line: 54,
	            column: 38
	          }
	        },
	        type: 'binary-expr',
	        locations: [{
	          start: {
	            line: 54,
	            column: 6
	          },
	          end: {
	            line: 54,
	            column: 20
	          }
	        }, {
	          start: {
	            line: 54,
	            column: 24
	          },
	          end: {
	            line: 54,
	            column: 38
	          }
	        }],
	        line: 54
	      }
	    },
	    s: {
	      '0': 0,
	      '1': 0,
	      '2': 0,
	      '3': 0,
	      '4': 0,
	      '5': 0,
	      '6': 0,
	      '7': 0,
	      '8': 0,
	      '9': 0,
	      '10': 0,
	      '11': 0,
	      '12': 0,
	      '13': 0,
	      '14': 0
	    },
	    f: {
	      '0': 0,
	      '1': 0
	    },
	    b: {
	      '0': [0, 0],
	      '1': [0, 0],
	      '2': [0, 0, 0, 0],
	      '3': [0, 0],
	      '4': [0, 0],
	      '5': [0, 0]
	    },
	    _coverageSchema: '332fd63041d2c1bcb487cc26dd0d5f7d97098a6c'
	  },
	      coverage = global[gcv] || (global[gcv] = {});

	  if (coverage[path] && coverage[path].hash === hash) {
	    return coverage[path];
	  }

	  coverageData.hash = hash;
	  return coverage[path] = coverageData;
	}();
	var source = (cov_ambywxk92.s[0]++, '@ptv-host');
	function parseMessageData(data) {
	  cov_ambywxk92.f[0]++;
	  cov_ambywxk92.s[1]++;

	  if (typeof data === 'string') {
	    cov_ambywxk92.b[0][0]++;
	    cov_ambywxk92.s[2]++;

	    try {
	      cov_ambywxk92.s[3]++;
	      data = JSON.parse(data);
	    } catch (error) {
	      cov_ambywxk92.s[4]++;
	      return {};
	    }
	  } else {
	    cov_ambywxk92.b[0][1]++;
	  }

	  cov_ambywxk92.s[5]++;
	  return data;
	}
	function postMessage(iframe, method, params) {
	  cov_ambywxk92.f[1]++;
	  cov_ambywxk92.s[6]++;

	  if ((cov_ambywxk92.b[2][0]++, !iframe) || (cov_ambywxk92.b[2][1]++, !iframe.el) || (cov_ambywxk92.b[2][2]++, !iframe.el.contentWindow) || (cov_ambywxk92.b[2][3]++, !iframe.el.contentWindow.postMessage)) {
	    cov_ambywxk92.b[1][0]++;
	    cov_ambywxk92.s[7]++;
	    return;
	  } else {
	    cov_ambywxk92.b[1][1]++;
	  }

	  var message = (cov_ambywxk92.s[8]++, {
	    method: method,
	    source: source
	  });
	  cov_ambywxk92.s[9]++;

	  if (params !== undefined) {
	    cov_ambywxk92.b[3][0]++;
	    cov_ambywxk92.s[10]++;
	    message.value = params;
	  } else {
	    cov_ambywxk92.b[3][1]++;
	  }

	  var ieVersion = (cov_ambywxk92.s[11]++, parseFloat(window_1.navigator.userAgent.toLowerCase().replace(/^.*msie (\d+).*$/, '$1')));
	  cov_ambywxk92.s[12]++;

	  if ((cov_ambywxk92.b[5][0]++, ieVersion >= 8) && (cov_ambywxk92.b[5][1]++, ieVersion < 10)) {
	    cov_ambywxk92.b[4][0]++;
	    cov_ambywxk92.s[13]++;
	    message = JSON.stringify(message);
	  } else {
	    cov_ambywxk92.b[4][1]++;
	  }

	  cov_ambywxk92.s[14]++;
	  iframe.el.contentWindow.postMessage(message, iframe.origin);
	}

	var cov_272gi5dcw = function () {
	  var path = '/home/runner/work/videojs-ptv/videojs-ptv/src/utils.js',
	      hash = '832b4a6b521a70e344559d0aadcd22068f33cb41',
	      Function = function () {}.constructor,
	      global = new Function('return this')(),
	      gcv = '__coverage__',
	      coverageData = {
	    path: '/home/runner/work/videojs-ptv/videojs-ptv/src/utils.js',
	    statementMap: {
	      '0': {
	        start: {
	          line: 7,
	          column: 25
	        },
	        end: {
	          line: 11,
	          column: 14
	        }
	      },
	      '1': {
	        start: {
	          line: 8,
	          column: 2
	        },
	        end: {
	          line: 11,
	          column: 14
	        }
	      },
	      '2': {
	        start: {
	          line: 9,
	          column: 19
	        },
	        end: {
	          line: 9,
	          column: 34
	        }
	      },
	      '3': {
	        start: {
	          line: 10,
	          column: 16
	        },
	        end: {
	          line: 10,
	          column: 72
	        }
	      }
	    },
	    fnMap: {
	      '0': {
	        name: '(anonymous_0)',
	        decl: {
	          start: {
	            line: 7,
	            column: 25
	          },
	          end: {
	            line: 7,
	            column: 26
	          }
	        },
	        loc: {
	          start: {
	            line: 8,
	            column: 2
	          },
	          end: {
	            line: 11,
	            column: 14
	          }
	        },
	        line: 8
	      },
	      '1': {
	        name: '(anonymous_1)',
	        decl: {
	          start: {
	            line: 9,
	            column: 12
	          },
	          end: {
	            line: 9,
	            column: 13
	          }
	        },
	        loc: {
	          start: {
	            line: 9,
	            column: 19
	          },
	          end: {
	            line: 9,
	            column: 34
	          }
	        },
	        line: 9
	      },
	      '2': {
	        name: '(anonymous_2)',
	        decl: {
	          start: {
	            line: 10,
	            column: 9
	          },
	          end: {
	            line: 10,
	            column: 10
	          }
	        },
	        loc: {
	          start: {
	            line: 10,
	            column: 16
	          },
	          end: {
	            line: 10,
	            column: 72
	          }
	        },
	        line: 10
	      }
	    },
	    branchMap: {},
	    s: {
	      '0': 0,
	      '1': 0,
	      '2': 0,
	      '3': 0
	    },
	    f: {
	      '0': 0,
	      '1': 0,
	      '2': 0
	    },
	    b: {},
	    _coverageSchema: '332fd63041d2c1bcb487cc26dd0d5f7d97098a6c'
	  },
	      coverage = global[gcv] || (global[gcv] = {});

	  if (coverage[path] && coverage[path].hash === hash) {
	    return coverage[path];
	  }

	  coverageData.hash = hash;
	  return coverage[path] = coverageData;
	}();

	cov_272gi5dcw.s[0]++;
	var serialize = function serialize(obj) {
	  cov_272gi5dcw.f[0]++;
	  cov_272gi5dcw.s[1]++;
	  return Object.keys(obj).filter(function (k) {
	    cov_272gi5dcw.f[1]++;
	    cov_272gi5dcw.s[2]++;
	    return obj[k] !== null;
	  }).map(function (k) {
	    cov_272gi5dcw.f[2]++;
	    cov_272gi5dcw.s[3]++;
	    return encodeURIComponent(k) + "=" + encodeURIComponent(obj[k]);
	  }).join('&');
	};

	var cov_1sttxmfv13 = function () {
	  var path = '/home/runner/work/videojs-ptv/videojs-ptv/src/embed.js',
	      hash = 'da295bfa513b6c17aec1dfe5c4efe0de8808c9d8',
	      Function = function () {}.constructor,
	      global = new Function('return this')(),
	      gcv = '__coverage__',
	      coverageData = {
	    path: '/home/runner/work/videojs-ptv/videojs-ptv/src/embed.js',
	    statementMap: {
	      '0': {
	        start: {
	          line: 8,
	          column: 17
	        },
	        end: {
	          line: 8,
	          column: 27
	        }
	      },
	      '1': {
	        start: {
	          line: 10,
	          column: 25
	        },
	        end: {
	          line: 14,
	          column: 1
	        }
	      },
	      '2': {
	        start: {
	          line: 16,
	          column: 24
	        },
	        end: {
	          line: 20,
	          column: 1
	        }
	      },
	      '3': {
	        start: {
	          line: 22,
	          column: 34
	        },
	        end: {
	          line: 27,
	          column: 2
	        }
	      },
	      '4': {
	        start: {
	          line: 22,
	          column: 41
	        },
	        end: {
	          line: 27,
	          column: 1
	        }
	      },
	      '5': {
	        start: {
	          line: 44,
	          column: 4
	        },
	        end: {
	          line: 44,
	          column: 61
	        }
	      },
	      '6': {
	        start: {
	          line: 55,
	          column: 4
	        },
	        end: {
	          line: 55,
	          column: 40
	        }
	      },
	      '7': {
	        start: {
	          line: 68,
	          column: 4
	        },
	        end: {
	          line: 68,
	          column: 30
	        }
	      },
	      '8': {
	        start: {
	          line: 69,
	          column: 4
	        },
	        end: {
	          line: 69,
	          column: 53
	        }
	      },
	      '9': {
	        start: {
	          line: 72,
	          column: 4
	        },
	        end: {
	          line: 72,
	          column: 66
	        }
	      },
	      '10': {
	        start: {
	          line: 73,
	          column: 4
	        },
	        end: {
	          line: 73,
	          column: 47
	        }
	      },
	      '11': {
	        start: {
	          line: 76,
	          column: 4
	        },
	        end: {
	          line: 76,
	          column: 55
	        }
	      },
	      '12': {
	        start: {
	          line: 77,
	          column: 4
	        },
	        end: {
	          line: 77,
	          column: 46
	        }
	      },
	      '13': {
	        start: {
	          line: 78,
	          column: 4
	        },
	        end: {
	          line: 78,
	          column: 38
	        }
	      },
	      '14': {
	        start: {
	          line: 79,
	          column: 4
	        },
	        end: {
	          line: 88,
	          column: 6
	        }
	      },
	      '15': {
	        start: {
	          line: 91,
	          column: 4
	        },
	        end: {
	          line: 91,
	          column: 70
	        }
	      },
	      '16': {
	        start: {
	          line: 94,
	          column: 4
	        },
	        end: {
	          line: 94,
	          column: 72
	        }
	      },
	      '17': {
	        start: {
	          line: 97,
	          column: 4
	        },
	        end: {
	          line: 97,
	          column: 57
	        }
	      },
	      '18': {
	        start: {
	          line: 98,
	          column: 4
	        },
	        end: {
	          line: 98,
	          column: 60
	        }
	      },
	      '19': {
	        start: {
	          line: 105,
	          column: 4
	        },
	        end: {
	          line: 105,
	          column: 63
	        }
	      },
	      '20': {
	        start: {
	          line: 106,
	          column: 4
	        },
	        end: {
	          line: 106,
	          column: 39
	        }
	      },
	      '21': {
	        start: {
	          line: 115,
	          column: 4
	        },
	        end: {
	          line: 115,
	          column: 27
	        }
	      },
	      '22': {
	        start: {
	          line: 124,
	          column: 4
	        },
	        end: {
	          line: 124,
	          column: 20
	        }
	      },
	      '23': {
	        start: {
	          line: 133,
	          column: 4
	        },
	        end: {
	          line: 133,
	          column: 24
	        }
	      },
	      '24': {
	        start: {
	          line: 140,
	          column: 4
	        },
	        end: {
	          line: 140,
	          column: 44
	        }
	      },
	      '25': {
	        start: {
	          line: 141,
	          column: 4
	        },
	        end: {
	          line: 141,
	          column: 20
	        }
	      },
	      '26': {
	        start: {
	          line: 142,
	          column: 4
	        },
	        end: {
	          line: 142,
	          column: 34
	        }
	      },
	      '27': {
	        start: {
	          line: 149,
	          column: 4
	        },
	        end: {
	          line: 153,
	          column: 5
	        }
	      },
	      '28': {
	        start: {
	          line: 150,
	          column: 6
	        },
	        end: {
	          line: 150,
	          column: 31
	        }
	      },
	      '29': {
	        start: {
	          line: 152,
	          column: 6
	        },
	        end: {
	          line: 152,
	          column: 41
	        }
	      },
	      '30': {
	        start: {
	          line: 162,
	          column: 4
	        },
	        end: {
	          line: 166,
	          column: 5
	        }
	      },
	      '31': {
	        start: {
	          line: 163,
	          column: 6
	        },
	        end: {
	          line: 163,
	          column: 39
	        }
	      },
	      '32': {
	        start: {
	          line: 165,
	          column: 6
	        },
	        end: {
	          line: 165,
	          column: 41
	        }
	      },
	      '33': {
	        start: {
	          line: 175,
	          column: 4
	        },
	        end: {
	          line: 175,
	          column: 39
	        }
	      },
	      '34': {
	        start: {
	          line: 184,
	          column: 4
	        },
	        end: {
	          line: 184,
	          column: 38
	        }
	      },
	      '35': {
	        start: {
	          line: 193,
	          column: 4
	        },
	        end: {
	          line: 193,
	          column: 40
	        }
	      },
	      '36': {
	        start: {
	          line: 202,
	          column: 4
	        },
	        end: {
	          line: 202,
	          column: 55
	        }
	      },
	      '37': {
	        start: {
	          line: 209,
	          column: 4
	        },
	        end: {
	          line: 213,
	          column: 5
	        }
	      },
	      '38': {
	        start: {
	          line: 210,
	          column: 6
	        },
	        end: {
	          line: 210,
	          column: 31
	        }
	      },
	      '39': {
	        start: {
	          line: 212,
	          column: 6
	        },
	        end: {
	          line: 212,
	          column: 40
	        }
	      },
	      '40': {
	        start: {
	          line: 220,
	          column: 4
	        },
	        end: {
	          line: 224,
	          column: 5
	        }
	      },
	      '41': {
	        start: {
	          line: 221,
	          column: 6
	        },
	        end: {
	          line: 221,
	          column: 32
	        }
	      },
	      '42': {
	        start: {
	          line: 223,
	          column: 6
	        },
	        end: {
	          line: 223,
	          column: 40
	        }
	      },
	      '43': {
	        start: {
	          line: 231,
	          column: 4
	        },
	        end: {
	          line: 235,
	          column: 5
	        }
	      },
	      '44': {
	        start: {
	          line: 232,
	          column: 6
	        },
	        end: {
	          line: 232,
	          column: 31
	        }
	      },
	      '45': {
	        start: {
	          line: 234,
	          column: 6
	        },
	        end: {
	          line: 234,
	          column: 41
	        }
	      },
	      '46': {
	        start: {
	          line: 244,
	          column: 4
	        },
	        end: {
	          line: 248,
	          column: 5
	        }
	      },
	      '47': {
	        start: {
	          line: 245,
	          column: 6
	        },
	        end: {
	          line: 245,
	          column: 46
	        }
	      },
	      '48': {
	        start: {
	          line: 247,
	          column: 6
	        },
	        end: {
	          line: 247,
	          column: 40
	        }
	      },
	      '49': {
	        start: {
	          line: 260,
	          column: 4
	        },
	        end: {
	          line: 260,
	          column: 34
	        }
	      },
	      '50': {
	        start: {
	          line: 271,
	          column: 29
	        },
	        end: {
	          line: 271,
	          column: 36
	        }
	      },
	      '51': {
	        start: {
	          line: 273,
	          column: 4
	        },
	        end: {
	          line: 298,
	          column: 5
	        }
	      },
	      '52': {
	        start: {
	          line: 274,
	          column: 22
	        },
	        end: {
	          line: 274,
	          column: 44
	        }
	      },
	      '53': {
	        start: {
	          line: 277,
	          column: 6
	        },
	        end: {
	          line: 280,
	          column: 7
	        }
	      },
	      '54': {
	        start: {
	          line: 278,
	          column: 8
	        },
	        end: {
	          line: 278,
	          column: 33
	        }
	      },
	      '55': {
	        start: {
	          line: 279,
	          column: 8
	        },
	        end: {
	          line: 279,
	          column: 34
	        }
	      },
	      '56': {
	        start: {
	          line: 282,
	          column: 6
	        },
	        end: {
	          line: 297,
	          column: 7
	        }
	      },
	      '57': {
	        start: {
	          line: 284,
	          column: 8
	        },
	        end: {
	          line: 284,
	          column: 41
	        }
	      },
	      '58': {
	        start: {
	          line: 285,
	          column: 8
	        },
	        end: {
	          line: 285,
	          column: 14
	        }
	      },
	      '59': {
	        start: {
	          line: 288,
	          column: 8
	        },
	        end: {
	          line: 288,
	          column: 51
	        }
	      },
	      '60': {
	        start: {
	          line: 289,
	          column: 8
	        },
	        end: {
	          line: 289,
	          column: 14
	        }
	      },
	      '61': {
	        start: {
	          line: 292,
	          column: 8
	        },
	        end: {
	          line: 292,
	          column: 37
	        }
	      },
	      '62': {
	        start: {
	          line: 293,
	          column: 8
	        },
	        end: {
	          line: 293,
	          column: 14
	        }
	      },
	      '63': {
	        start: {
	          line: 296,
	          column: 8
	        },
	        end: {
	          line: 296,
	          column: 15
	        }
	      },
	      '64': {
	        start: {
	          line: 308,
	          column: 4
	        },
	        end: {
	          line: 314,
	          column: 5
	        }
	      },
	      '65': {
	        start: {
	          line: 309,
	          column: 6
	        },
	        end: {
	          line: 311,
	          column: 7
	        }
	      },
	      '66': {
	        start: {
	          line: 310,
	          column: 8
	        },
	        end: {
	          line: 310,
	          column: 23
	        }
	      },
	      '67': {
	        start: {
	          line: 323,
	          column: 47
	        },
	        end: {
	          line: 323,
	          column: 65
	        }
	      },
	      '68': {
	        start: {
	          line: 325,
	          column: 4
	        },
	        end: {
	          line: 327,
	          column: 5
	        }
	      },
	      '69': {
	        start: {
	          line: 326,
	          column: 6
	        },
	        end: {
	          line: 326,
	          column: 13
	        }
	      },
	      '70': {
	        start: {
	          line: 329,
	          column: 4
	        },
	        end: {
	          line: 331,
	          column: 5
	        }
	      },
	      '71': {
	        start: {
	          line: 330,
	          column: 6
	        },
	        end: {
	          line: 330,
	          column: 24
	        }
	      },
	      '72': {
	        start: {
	          line: 333,
	          column: 4
	        },
	        end: {
	          line: 335,
	          column: 5
	        }
	      },
	      '73': {
	        start: {
	          line: 334,
	          column: 6
	        },
	        end: {
	          line: 334,
	          column: 19
	        }
	      },
	      '74': {
	        start: {
	          line: 337,
	          column: 4
	        },
	        end: {
	          line: 339,
	          column: 5
	        }
	      },
	      '75': {
	        start: {
	          line: 338,
	          column: 6
	        },
	        end: {
	          line: 338,
	          column: 18
	        }
	      },
	      '76': {
	        start: {
	          line: 341,
	          column: 4
	        },
	        end: {
	          line: 343,
	          column: 5
	        }
	      },
	      '77': {
	        start: {
	          line: 342,
	          column: 6
	        },
	        end: {
	          line: 342,
	          column: 18
	        }
	      },
	      '78': {
	        start: {
	          line: 345,
	          column: 4
	        },
	        end: {
	          line: 347,
	          column: 5
	        }
	      },
	      '79': {
	        start: {
	          line: 346,
	          column: 6
	        },
	        end: {
	          line: 346,
	          column: 18
	        }
	      },
	      '80': {
	        start: {
	          line: 349,
	          column: 4
	        },
	        end: {
	          line: 351,
	          column: 5
	        }
	      },
	      '81': {
	        start: {
	          line: 350,
	          column: 6
	        },
	        end: {
	          line: 350,
	          column: 28
	        }
	      },
	      '82': {
	        start: {
	          line: 354,
	          column: 4
	        },
	        end: {
	          line: 354,
	          column: 53
	        }
	      }
	    },
	    fnMap: {
	      '0': {
	        name: '(anonymous_0)',
	        decl: {
	          start: {
	            line: 22,
	            column: 34
	          },
	          end: {
	            line: 22,
	            column: 35
	          }
	        },
	        loc: {
	          start: {
	            line: 22,
	            column: 41
	          },
	          end: {
	            line: 27,
	            column: 1
	          }
	        },
	        line: 22
	      },
	      '1': {
	        name: '(anonymous_1)',
	        decl: {
	          start: {
	            line: 43,
	            column: 2
	          },
	          end: {
	            line: 43,
	            column: 3
	          }
	        },
	        loc: {
	          start: {
	            line: 43,
	            column: 48
	          },
	          end: {
	            line: 45,
	            column: 3
	          }
	        },
	        line: 43
	      },
	      '2': {
	        name: '(anonymous_2)',
	        decl: {
	          start: {
	            line: 54,
	            column: 2
	          },
	          end: {
	            line: 54,
	            column: 3
	          }
	        },
	        loc: {
	          start: {
	            line: 54,
	            column: 28
	          },
	          end: {
	            line: 56,
	            column: 3
	          }
	        },
	        line: 54
	      },
	      '3': {
	        name: '(anonymous_3)',
	        decl: {
	          start: {
	            line: 66,
	            column: 2
	          },
	          end: {
	            line: 66,
	            column: 3
	          }
	        },
	        loc: {
	          start: {
	            line: 66,
	            column: 34
	          },
	          end: {
	            line: 99,
	            column: 3
	          }
	        },
	        line: 66
	      },
	      '4': {
	        name: '(anonymous_4)',
	        decl: {
	          start: {
	            line: 104,
	            column: 2
	          },
	          end: {
	            line: 104,
	            column: 3
	          }
	        },
	        loc: {
	          start: {
	            line: 104,
	            column: 12
	          },
	          end: {
	            line: 107,
	            column: 3
	          }
	        },
	        line: 104
	      },
	      '5': {
	        name: '(anonymous_5)',
	        decl: {
	          start: {
	            line: 114,
	            column: 2
	          },
	          end: {
	            line: 114,
	            column: 3
	          }
	        },
	        loc: {
	          start: {
	            line: 114,
	            column: 18
	          },
	          end: {
	            line: 116,
	            column: 3
	          }
	        },
	        line: 114
	      },
	      '6': {
	        name: '(anonymous_6)',
	        decl: {
	          start: {
	            line: 123,
	            column: 2
	          },
	          end: {
	            line: 123,
	            column: 3
	          }
	        },
	        loc: {
	          start: {
	            line: 123,
	            column: 11
	          },
	          end: {
	            line: 125,
	            column: 3
	          }
	        },
	        line: 123
	      },
	      '7': {
	        name: '(anonymous_7)',
	        decl: {
	          start: {
	            line: 132,
	            column: 2
	          },
	          end: {
	            line: 132,
	            column: 3
	          }
	        },
	        loc: {
	          start: {
	            line: 132,
	            column: 15
	          },
	          end: {
	            line: 134,
	            column: 3
	          }
	        },
	        line: 132
	      },
	      '8': {
	        name: '(anonymous_8)',
	        decl: {
	          start: {
	            line: 139,
	            column: 2
	          },
	          end: {
	            line: 139,
	            column: 3
	          }
	        },
	        loc: {
	          start: {
	            line: 139,
	            column: 12
	          },
	          end: {
	            line: 143,
	            column: 3
	          }
	        },
	        line: 139
	      },
	      '9': {
	        name: '(anonymous_9)',
	        decl: {
	          start: {
	            line: 148,
	            column: 2
	          },
	          end: {
	            line: 148,
	            column: 3
	          }
	        },
	        loc: {
	          start: {
	            line: 148,
	            column: 9
	          },
	          end: {
	            line: 154,
	            column: 3
	          }
	        },
	        line: 148
	      },
	      '10': {
	        name: '(anonymous_10)',
	        decl: {
	          start: {
	            line: 161,
	            column: 2
	          },
	          end: {
	            line: 161,
	            column: 3
	          }
	        },
	        loc: {
	          start: {
	            line: 161,
	            column: 15
	          },
	          end: {
	            line: 167,
	            column: 3
	          }
	        },
	        line: 161
	      },
	      '11': {
	        name: '(anonymous_11)',
	        decl: {
	          start: {
	            line: 174,
	            column: 2
	          },
	          end: {
	            line: 174,
	            column: 3
	          }
	        },
	        loc: {
	          start: {
	            line: 174,
	            column: 17
	          },
	          end: {
	            line: 176,
	            column: 3
	          }
	        },
	        line: 174
	      },
	      '12': {
	        name: '(anonymous_12)',
	        decl: {
	          start: {
	            line: 183,
	            column: 2
	          },
	          end: {
	            line: 183,
	            column: 3
	          }
	        },
	        loc: {
	          start: {
	            line: 183,
	            column: 16
	          },
	          end: {
	            line: 185,
	            column: 3
	          }
	        },
	        line: 183
	      },
	      '13': {
	        name: '(anonymous_13)',
	        decl: {
	          start: {
	            line: 192,
	            column: 2
	          },
	          end: {
	            line: 192,
	            column: 3
	          }
	        },
	        loc: {
	          start: {
	            line: 192,
	            column: 18
	          },
	          end: {
	            line: 194,
	            column: 3
	          }
	        },
	        line: 192
	      },
	      '14': {
	        name: '(anonymous_14)',
	        decl: {
	          start: {
	            line: 201,
	            column: 2
	          },
	          end: {
	            line: 201,
	            column: 3
	          }
	        },
	        loc: {
	          start: {
	            line: 201,
	            column: 33
	          },
	          end: {
	            line: 203,
	            column: 3
	          }
	        },
	        line: 201
	      },
	      '15': {
	        name: '(anonymous_15)',
	        decl: {
	          start: {
	            line: 208,
	            column: 2
	          },
	          end: {
	            line: 208,
	            column: 3
	          }
	        },
	        loc: {
	          start: {
	            line: 208,
	            column: 9
	          },
	          end: {
	            line: 214,
	            column: 3
	          }
	        },
	        line: 208
	      },
	      '16': {
	        name: '(anonymous_16)',
	        decl: {
	          start: {
	            line: 219,
	            column: 2
	          },
	          end: {
	            line: 219,
	            column: 3
	          }
	        },
	        loc: {
	          start: {
	            line: 219,
	            column: 10
	          },
	          end: {
	            line: 225,
	            column: 3
	          }
	        },
	        line: 219
	      },
	      '17': {
	        name: '(anonymous_17)',
	        decl: {
	          start: {
	            line: 230,
	            column: 2
	          },
	          end: {
	            line: 230,
	            column: 3
	          }
	        },
	        loc: {
	          start: {
	            line: 230,
	            column: 9
	          },
	          end: {
	            line: 236,
	            column: 3
	          }
	        },
	        line: 230
	      },
	      '18': {
	        name: '(anonymous_18)',
	        decl: {
	          start: {
	            line: 243,
	            column: 2
	          },
	          end: {
	            line: 243,
	            column: 3
	          }
	        },
	        loc: {
	          start: {
	            line: 243,
	            column: 22
	          },
	          end: {
	            line: 249,
	            column: 3
	          }
	        },
	        line: 243
	      },
	      '19': {
	        name: '(anonymous_19)',
	        decl: {
	          start: {
	            line: 259,
	            column: 2
	          },
	          end: {
	            line: 259,
	            column: 3
	          }
	        },
	        loc: {
	          start: {
	            line: 259,
	            column: 26
	          },
	          end: {
	            line: 261,
	            column: 3
	          }
	        },
	        line: 259
	      },
	      '20': {
	        name: '(anonymous_20)',
	        decl: {
	          start: {
	            line: 270,
	            column: 2
	          },
	          end: {
	            line: 270,
	            column: 3
	          }
	        },
	        loc: {
	          start: {
	            line: 270,
	            column: 26
	          },
	          end: {
	            line: 299,
	            column: 3
	          }
	        },
	        line: 270
	      },
	      '21': {
	        name: '(anonymous_21)',
	        decl: {
	          start: {
	            line: 307,
	            column: 2
	          },
	          end: {
	            line: 307,
	            column: 3
	          }
	        },
	        loc: {
	          start: {
	            line: 307,
	            column: 12
	          },
	          end: {
	            line: 315,
	            column: 3
	          }
	        },
	        line: 307
	      },
	      '22': {
	        name: '(anonymous_22)',
	        decl: {
	          start: {
	            line: 322,
	            column: 2
	          },
	          end: {
	            line: 322,
	            column: 3
	          }
	        },
	        loc: {
	          start: {
	            line: 322,
	            column: 23
	          },
	          end: {
	            line: 355,
	            column: 3
	          }
	        },
	        line: 322
	      }
	    },
	    branchMap: {
	      '0': {
	        loc: {
	          start: {
	            line: 149,
	            column: 4
	          },
	          end: {
	            line: 153,
	            column: 5
	          }
	        },
	        type: 'if',
	        locations: [{
	          start: {
	            line: 149,
	            column: 4
	          },
	          end: {
	            line: 153,
	            column: 5
	          }
	        }, {
	          start: {
	            line: 149,
	            column: 4
	          },
	          end: {
	            line: 153,
	            column: 5
	          }
	        }],
	        line: 149
	      },
	      '1': {
	        loc: {
	          start: {
	            line: 162,
	            column: 4
	          },
	          end: {
	            line: 166,
	            column: 5
	          }
	        },
	        type: 'if',
	        locations: [{
	          start: {
	            line: 162,
	            column: 4
	          },
	          end: {
	            line: 166,
	            column: 5
	          }
	        }, {
	          start: {
	            line: 162,
	            column: 4
	          },
	          end: {
	            line: 166,
	            column: 5
	          }
	        }],
	        line: 162
	      },
	      '2': {
	        loc: {
	          start: {
	            line: 209,
	            column: 4
	          },
	          end: {
	            line: 213,
	            column: 5
	          }
	        },
	        type: 'if',
	        locations: [{
	          start: {
	            line: 209,
	            column: 4
	          },
	          end: {
	            line: 213,
	            column: 5
	          }
	        }, {
	          start: {
	            line: 209,
	            column: 4
	          },
	          end: {
	            line: 213,
	            column: 5
	          }
	        }],
	        line: 209
	      },
	      '3': {
	        loc: {
	          start: {
	            line: 220,
	            column: 4
	          },
	          end: {
	            line: 224,
	            column: 5
	          }
	        },
	        type: 'if',
	        locations: [{
	          start: {
	            line: 220,
	            column: 4
	          },
	          end: {
	            line: 224,
	            column: 5
	          }
	        }, {
	          start: {
	            line: 220,
	            column: 4
	          },
	          end: {
	            line: 224,
	            column: 5
	          }
	        }],
	        line: 220
	      },
	      '4': {
	        loc: {
	          start: {
	            line: 231,
	            column: 4
	          },
	          end: {
	            line: 235,
	            column: 5
	          }
	        },
	        type: 'if',
	        locations: [{
	          start: {
	            line: 231,
	            column: 4
	          },
	          end: {
	            line: 235,
	            column: 5
	          }
	        }, {
	          start: {
	            line: 231,
	            column: 4
	          },
	          end: {
	            line: 235,
	            column: 5
	          }
	        }],
	        line: 231
	      },
	      '5': {
	        loc: {
	          start: {
	            line: 244,
	            column: 4
	          },
	          end: {
	            line: 248,
	            column: 5
	          }
	        },
	        type: 'if',
	        locations: [{
	          start: {
	            line: 244,
	            column: 4
	          },
	          end: {
	            line: 248,
	            column: 5
	          }
	        }, {
	          start: {
	            line: 244,
	            column: 4
	          },
	          end: {
	            line: 248,
	            column: 5
	          }
	        }],
	        line: 244
	      },
	      '6': {
	        loc: {
	          start: {
	            line: 273,
	            column: 4
	          },
	          end: {
	            line: 298,
	            column: 5
	          }
	        },
	        type: 'if',
	        locations: [{
	          start: {
	            line: 273,
	            column: 4
	          },
	          end: {
	            line: 298,
	            column: 5
	          }
	        }, {
	          start: {
	            line: 273,
	            column: 4
	          },
	          end: {
	            line: 298,
	            column: 5
	          }
	        }],
	        line: 273
	      },
	      '7': {
	        loc: {
	          start: {
	            line: 277,
	            column: 6
	          },
	          end: {
	            line: 280,
	            column: 7
	          }
	        },
	        type: 'if',
	        locations: [{
	          start: {
	            line: 277,
	            column: 6
	          },
	          end: {
	            line: 280,
	            column: 7
	          }
	        }, {
	          start: {
	            line: 277,
	            column: 6
	          },
	          end: {
	            line: 280,
	            column: 7
	          }
	        }],
	        line: 277
	      },
	      '8': {
	        loc: {
	          start: {
	            line: 282,
	            column: 6
	          },
	          end: {
	            line: 297,
	            column: 7
	          }
	        },
	        type: 'switch',
	        locations: [{
	          start: {
	            line: 283,
	            column: 6
	          },
	          end: {
	            line: 285,
	            column: 14
	          }
	        }, {
	          start: {
	            line: 287,
	            column: 6
	          },
	          end: {
	            line: 289,
	            column: 14
	          }
	        }, {
	          start: {
	            line: 291,
	            column: 6
	          },
	          end: {
	            line: 293,
	            column: 14
	          }
	        }, {
	          start: {
	            line: 295,
	            column: 6
	          },
	          end: {
	            line: 296,
	            column: 15
	          }
	        }],
	        line: 282
	      },
	      '9': {
	        loc: {
	          start: {
	            line: 309,
	            column: 6
	          },
	          end: {
	            line: 311,
	            column: 7
	          }
	        },
	        type: 'if',
	        locations: [{
	          start: {
	            line: 309,
	            column: 6
	          },
	          end: {
	            line: 311,
	            column: 7
	          }
	        }, {
	          start: {
	            line: 309,
	            column: 6
	          },
	          end: {
	            line: 311,
	            column: 7
	          }
	        }],
	        line: 309
	      },
	      '10': {
	        loc: {
	          start: {
	            line: 325,
	            column: 4
	          },
	          end: {
	            line: 327,
	            column: 5
	          }
	        },
	        type: 'if',
	        locations: [{
	          start: {
	            line: 325,
	            column: 4
	          },
	          end: {
	            line: 327,
	            column: 5
	          }
	        }, {
	          start: {
	            line: 325,
	            column: 4
	          },
	          end: {
	            line: 327,
	            column: 5
	          }
	        }],
	        line: 325
	      },
	      '11': {
	        loc: {
	          start: {
	            line: 329,
	            column: 4
	          },
	          end: {
	            line: 331,
	            column: 5
	          }
	        },
	        type: 'if',
	        locations: [{
	          start: {
	            line: 329,
	            column: 4
	          },
	          end: {
	            line: 331,
	            column: 5
	          }
	        }, {
	          start: {
	            line: 329,
	            column: 4
	          },
	          end: {
	            line: 331,
	            column: 5
	          }
	        }],
	        line: 329
	      },
	      '12': {
	        loc: {
	          start: {
	            line: 333,
	            column: 4
	          },
	          end: {
	            line: 335,
	            column: 5
	          }
	        },
	        type: 'if',
	        locations: [{
	          start: {
	            line: 333,
	            column: 4
	          },
	          end: {
	            line: 335,
	            column: 5
	          }
	        }, {
	          start: {
	            line: 333,
	            column: 4
	          },
	          end: {
	            line: 335,
	            column: 5
	          }
	        }],
	        line: 333
	      },
	      '13': {
	        loc: {
	          start: {
	            line: 337,
	            column: 4
	          },
	          end: {
	            line: 339,
	            column: 5
	          }
	        },
	        type: 'if',
	        locations: [{
	          start: {
	            line: 337,
	            column: 4
	          },
	          end: {
	            line: 339,
	            column: 5
	          }
	        }, {
	          start: {
	            line: 337,
	            column: 4
	          },
	          end: {
	            line: 339,
	            column: 5
	          }
	        }],
	        line: 337
	      },
	      '14': {
	        loc: {
	          start: {
	            line: 341,
	            column: 4
	          },
	          end: {
	            line: 343,
	            column: 5
	          }
	        },
	        type: 'if',
	        locations: [{
	          start: {
	            line: 341,
	            column: 4
	          },
	          end: {
	            line: 343,
	            column: 5
	          }
	        }, {
	          start: {
	            line: 341,
	            column: 4
	          },
	          end: {
	            line: 343,
	            column: 5
	          }
	        }],
	        line: 341
	      },
	      '15': {
	        loc: {
	          start: {
	            line: 345,
	            column: 4
	          },
	          end: {
	            line: 347,
	            column: 5
	          }
	        },
	        type: 'if',
	        locations: [{
	          start: {
	            line: 345,
	            column: 4
	          },
	          end: {
	            line: 347,
	            column: 5
	          }
	        }, {
	          start: {
	            line: 345,
	            column: 4
	          },
	          end: {
	            line: 347,
	            column: 5
	          }
	        }],
	        line: 345
	      },
	      '16': {
	        loc: {
	          start: {
	            line: 349,
	            column: 4
	          },
	          end: {
	            line: 351,
	            column: 5
	          }
	        },
	        type: 'if',
	        locations: [{
	          start: {
	            line: 349,
	            column: 4
	          },
	          end: {
	            line: 351,
	            column: 5
	          }
	        }, {
	          start: {
	            line: 349,
	            column: 4
	          },
	          end: {
	            line: 351,
	            column: 5
	          }
	        }],
	        line: 349
	      }
	    },
	    s: {
	      '0': 0,
	      '1': 0,
	      '2': 0,
	      '3': 0,
	      '4': 0,
	      '5': 0,
	      '6': 0,
	      '7': 0,
	      '8': 0,
	      '9': 0,
	      '10': 0,
	      '11': 0,
	      '12': 0,
	      '13': 0,
	      '14': 0,
	      '15': 0,
	      '16': 0,
	      '17': 0,
	      '18': 0,
	      '19': 0,
	      '20': 0,
	      '21': 0,
	      '22': 0,
	      '23': 0,
	      '24': 0,
	      '25': 0,
	      '26': 0,
	      '27': 0,
	      '28': 0,
	      '29': 0,
	      '30': 0,
	      '31': 0,
	      '32': 0,
	      '33': 0,
	      '34': 0,
	      '35': 0,
	      '36': 0,
	      '37': 0,
	      '38': 0,
	      '39': 0,
	      '40': 0,
	      '41': 0,
	      '42': 0,
	      '43': 0,
	      '44': 0,
	      '45': 0,
	      '46': 0,
	      '47': 0,
	      '48': 0,
	      '49': 0,
	      '50': 0,
	      '51': 0,
	      '52': 0,
	      '53': 0,
	      '54': 0,
	      '55': 0,
	      '56': 0,
	      '57': 0,
	      '58': 0,
	      '59': 0,
	      '60': 0,
	      '61': 0,
	      '62': 0,
	      '63': 0,
	      '64': 0,
	      '65': 0,
	      '66': 0,
	      '67': 0,
	      '68': 0,
	      '69': 0,
	      '70': 0,
	      '71': 0,
	      '72': 0,
	      '73': 0,
	      '74': 0,
	      '75': 0,
	      '76': 0,
	      '77': 0,
	      '78': 0,
	      '79': 0,
	      '80': 0,
	      '81': 0,
	      '82': 0
	    },
	    f: {
	      '0': 0,
	      '1': 0,
	      '2': 0,
	      '3': 0,
	      '4': 0,
	      '5': 0,
	      '6': 0,
	      '7': 0,
	      '8': 0,
	      '9': 0,
	      '10': 0,
	      '11': 0,
	      '12': 0,
	      '13': 0,
	      '14': 0,
	      '15': 0,
	      '16': 0,
	      '17': 0,
	      '18': 0,
	      '19': 0,
	      '20': 0,
	      '21': 0,
	      '22': 0
	    },
	    b: {
	      '0': [0, 0],
	      '1': [0, 0],
	      '2': [0, 0],
	      '3': [0, 0],
	      '4': [0, 0],
	      '5': [0, 0],
	      '6': [0, 0],
	      '7': [0, 0],
	      '8': [0, 0, 0, 0],
	      '9': [0, 0],
	      '10': [0, 0],
	      '11': [0, 0],
	      '12': [0, 0],
	      '13': [0, 0],
	      '14': [0, 0],
	      '15': [0, 0],
	      '16': [0, 0]
	    },
	    _coverageSchema: '332fd63041d2c1bcb487cc26dd0d5f7d97098a6c'
	  },
	      coverage = global[gcv] || (global[gcv] = {});

	  if (coverage[path] && coverage[path].hash === hash) {
	    return coverage[path];
	  }

	  coverageData.hash = hash;
	  return coverage[path] = coverageData;
	}();
	var PROTOCOL = (cov_1sttxmfv13.s[0]++, 'https://');
	var defaultCallbacks = (cov_1sttxmfv13.s[1]++, {
	  onClickMiss: Function.prototype,
	  onConfigFailure: Function.prototype,
	  onConfigReady: Function.prototype
	});
	var requiredOptions = (cov_1sttxmfv13.s[2]++, {
	  embedHost: null,
	  excludePlayer: true,
	  iframe: true
	});
	cov_1sttxmfv13.s[3]++;

	var createDefaultPreloadState = function createDefaultPreloadState() {
	  cov_1sttxmfv13.f[0]++;
	  cov_1sttxmfv13.s[4]++;
	  return {
	    config: undefined,
	    started: undefined,
	    visible: undefined,
	    time: -1
	  };
	};

	var PtvEmbed = /*#__PURE__*/function () {
	  PtvEmbed.assignIframeSource = function assignIframeSource(el, origin, config) {
	    cov_1sttxmfv13.f[1]++;
	    cov_1sttxmfv13.s[5]++;
	    el.setAttribute('src', origin + '?' + serialize(config));
	  };

	  PtvEmbed.getOrigin = function getOrigin(options) {
	    cov_1sttxmfv13.f[2]++;
	    cov_1sttxmfv13.s[6]++;
	    return PROTOCOL + options.embedHost;
	  };

	  function PtvEmbed(options, callbacks) {
	    cov_1sttxmfv13.f[3]++;
	    cov_1sttxmfv13.s[7]++;
	    this.isSdkLoaded_ = false;
	    cov_1sttxmfv13.s[8]++;
	    this.preloadState_ = createDefaultPreloadState();
	    cov_1sttxmfv13.s[9]++;
	    this.config_ = videojs__default['default'].mergeOptions(options, requiredOptions);
	    cov_1sttxmfv13.s[10]++;
	    this.origin_ = PtvEmbed.getOrigin(options);
	    cov_1sttxmfv13.s[11]++;
	    this.el_ = window_1.document.createElement('iframe');
	    cov_1sttxmfv13.s[12]++;
	    this.el_.onload = this.onLoad_.bind(this);
	    cov_1sttxmfv13.s[13]++;
	    this.el_.className = 'ptv-iframe';
	    cov_1sttxmfv13.s[14]++;
	    this.el_.style.cssText = "\n      position: absolute;\n      top: 0;\n      left: 0;\n      width: 100%;\n      height: 100%;\n      max-width: 100%;\n      max-height: 100%;\n      border: none;\n    ";
	    cov_1sttxmfv13.s[15]++;
	    PtvEmbed.assignIframeSource(this.el_, this.origin_, this.config_);
	    cov_1sttxmfv13.s[16]++;
	    this.callbacks_ = videojs__default['default'].mergeOptions(defaultCallbacks, callbacks);
	    cov_1sttxmfv13.s[17]++;
	    this.handleMessage_ = this.handleMessage_.bind(this);
	    cov_1sttxmfv13.s[18]++;
	    window_1.addEventListener('message', this.handleMessage_);
	  }

	  var _proto = PtvEmbed.prototype;

	  _proto.dispose = function dispose() {
	    cov_1sttxmfv13.f[4]++;
	    cov_1sttxmfv13.s[19]++;
	    window_1.removeEventListener('message', this.handleMessage_);
	    cov_1sttxmfv13.s[20]++;
	    this.callbacks_ = defaultCallbacks;
	  };

	  _proto.destroy = function destroy() {
	    cov_1sttxmfv13.f[8]++;
	    cov_1sttxmfv13.s[24]++;
	    this.el.parentNode.removeChild(this.el);
	    cov_1sttxmfv13.s[25]++;
	    this.el_ = null;
	    cov_1sttxmfv13.s[26]++;
	    this.isSdkLoaded_ = undefined;
	  };

	  _proto.hide = function hide() {
	    cov_1sttxmfv13.f[9]++;
	    cov_1sttxmfv13.s[27]++;

	    if (this.isSdkLoaded_) {
	      cov_1sttxmfv13.b[0][0]++;
	      cov_1sttxmfv13.s[28]++;
	      this.callMethod_('hide');
	    } else {
	      cov_1sttxmfv13.b[0][1]++;
	      cov_1sttxmfv13.s[29]++;
	      this.preloadState_.visible = false;
	    }
	  };

	  _proto.load = function load(config) {
	    cov_1sttxmfv13.f[10]++;
	    cov_1sttxmfv13.s[30]++;

	    if (this.isSdkLoaded_) {
	      cov_1sttxmfv13.b[1][0]++;
	      cov_1sttxmfv13.s[31]++;
	      this.callMethod_('load', config);
	    } else {
	      cov_1sttxmfv13.b[1][1]++;
	      cov_1sttxmfv13.s[32]++;
	      this.preloadState_.config = config;
	    }
	  };

	  _proto.off = function off(eventName) {
	    cov_1sttxmfv13.f[11]++;
	    cov_1sttxmfv13.s[33]++;
	    this.callMethod_('off', eventName);
	  };

	  _proto.on = function on(eventName) {
	    cov_1sttxmfv13.f[12]++;
	    cov_1sttxmfv13.s[34]++;
	    this.callMethod_('on', eventName);
	  };

	  _proto.once = function once(eventName) {
	    cov_1sttxmfv13.f[13]++;
	    cov_1sttxmfv13.s[35]++;
	    this.callMethod_('once', eventName);
	  };

	  _proto.removeAllListeners = function removeAllListeners(eventNames) {
	    cov_1sttxmfv13.f[14]++;
	    cov_1sttxmfv13.s[36]++;
	    this.callMethod_('removeAllListeners', eventNames);
	  };

	  _proto.show = function show() {
	    cov_1sttxmfv13.f[15]++;
	    cov_1sttxmfv13.s[37]++;

	    if (this.isSdkLoaded_) {
	      cov_1sttxmfv13.b[2][0]++;
	      cov_1sttxmfv13.s[38]++;
	      this.callMethod_('show');
	    } else {
	      cov_1sttxmfv13.b[2][1]++;
	      cov_1sttxmfv13.s[39]++;
	      this.preloadState_.visible = true;
	    }
	  };

	  _proto.start = function start() {
	    cov_1sttxmfv13.f[16]++;
	    cov_1sttxmfv13.s[40]++;

	    if (this.isSdkLoaded_) {
	      cov_1sttxmfv13.b[3][0]++;
	      cov_1sttxmfv13.s[41]++;
	      this.callMethod_('start');
	    } else {
	      cov_1sttxmfv13.b[3][1]++;
	      cov_1sttxmfv13.s[42]++;
	      this.preloadState_.started = true;
	    }
	  };

	  _proto.stop = function stop() {
	    cov_1sttxmfv13.f[17]++;
	    cov_1sttxmfv13.s[43]++;

	    if (this.isSdkLoaded_) {
	      cov_1sttxmfv13.b[4][0]++;
	      cov_1sttxmfv13.s[44]++;
	      this.callMethod_('stop');
	    } else {
	      cov_1sttxmfv13.b[4][1]++;
	      cov_1sttxmfv13.s[45]++;
	      this.preloadState_.started = false;
	    }
	  };

	  _proto.timeUpdate = function timeUpdate(seconds) {
	    cov_1sttxmfv13.f[18]++;
	    cov_1sttxmfv13.s[46]++;

	    if (this.isSdkLoaded_) {
	      cov_1sttxmfv13.b[5][0]++;
	      cov_1sttxmfv13.s[47]++;
	      this.callMethod_('timeUpdate', seconds);
	    } else {
	      cov_1sttxmfv13.b[5][1]++;
	      cov_1sttxmfv13.s[48]++;
	      this.preloadState_.time = seconds;
	    }
	  };

	  _proto.callMethod_ = function callMethod_(name, args) {
	    cov_1sttxmfv13.f[19]++;
	    cov_1sttxmfv13.s[49]++;
	    postMessage(this, name, args);
	  };

	  _proto.handleMessage_ = function handleMessage_(message) {
	    cov_1sttxmfv13.f[20]++;

	    var _ref = (cov_1sttxmfv13.s[50]++, message),
	        data = _ref.data,
	        origin = _ref.origin;

	    cov_1sttxmfv13.s[51]++;

	    if (origin === this.origin_) {
	      cov_1sttxmfv13.b[6][0]++;
	      var payload = (cov_1sttxmfv13.s[52]++, parseMessageData(data));
	      cov_1sttxmfv13.s[53]++;

	      if (!this.isSdkLoaded_) {
	        cov_1sttxmfv13.b[7][0]++;
	        cov_1sttxmfv13.s[54]++;
	        this.isSdkLoaded_ = true;
	        cov_1sttxmfv13.s[55]++;
	        this.applyPreloadState_();
	      } else {
	        cov_1sttxmfv13.b[7][1]++;
	      }

	      cov_1sttxmfv13.s[56]++;

	      switch (payload.type) {
	        case SdkEvents.CONFIG_FAILURE:
	          cov_1sttxmfv13.b[8][0]++;
	          cov_1sttxmfv13.s[57]++;
	          this.callbacks.onConfigFailure();
	          cov_1sttxmfv13.s[58]++;
	          break;

	        case SdkEvents.CONFIG_READY:
	          cov_1sttxmfv13.b[8][1]++;
	          cov_1sttxmfv13.s[59]++;
	          this.callbacks.onConfigReady(payload.data);
	          cov_1sttxmfv13.s[60]++;
	          break;

	        case SdkEvents.CLICK_MISS:
	          cov_1sttxmfv13.b[8][2]++;
	          cov_1sttxmfv13.s[61]++;
	          this.callbacks.onClickMiss();
	          cov_1sttxmfv13.s[62]++;
	          break;

	        default:
	          cov_1sttxmfv13.b[8][3]++;
	          cov_1sttxmfv13.s[63]++;
	          return;
	      }
	    } else {
	      cov_1sttxmfv13.b[6][1]++;
	    }
	  };

	  _proto.onLoad_ = function onLoad_() {
	    cov_1sttxmfv13.f[21]++;
	    cov_1sttxmfv13.s[64]++;

	    try {
	      cov_1sttxmfv13.s[65]++;

	      if (this.el.contentDocument.body.innerText === 'NOT FOUND') {
	        cov_1sttxmfv13.b[9][0]++;
	        cov_1sttxmfv13.s[66]++;
	        this.destroy();
	      } else {
	        cov_1sttxmfv13.b[9][1]++;
	      }
	    } catch (e) {}
	  };

	  _proto.applyPreloadState_ = function applyPreloadState_() {
	    cov_1sttxmfv13.f[22]++;

	    var _ref2 = (cov_1sttxmfv13.s[67]++, this.preloadState_),
	        config = _ref2.config,
	        started = _ref2.started,
	        time = _ref2.time,
	        visible = _ref2.visible;

	    cov_1sttxmfv13.s[68]++;

	    if (!this.isSdkLoaded_) {
	      cov_1sttxmfv13.b[10][0]++;
	      cov_1sttxmfv13.s[69]++;
	      return;
	    } else {
	      cov_1sttxmfv13.b[10][1]++;
	    }

	    cov_1sttxmfv13.s[70]++;

	    if (config) {
	      cov_1sttxmfv13.b[11][0]++;
	      cov_1sttxmfv13.s[71]++;
	      this.load(config);
	    } else {
	      cov_1sttxmfv13.b[11][1]++;
	    }

	    cov_1sttxmfv13.s[72]++;

	    if (started === true) {
	      cov_1sttxmfv13.b[12][0]++;
	      cov_1sttxmfv13.s[73]++;
	      this.start();
	    } else {
	      cov_1sttxmfv13.b[12][1]++;
	    }

	    cov_1sttxmfv13.s[74]++;

	    if (started === false) {
	      cov_1sttxmfv13.b[13][0]++;
	      cov_1sttxmfv13.s[75]++;
	      this.stop();
	    } else {
	      cov_1sttxmfv13.b[13][1]++;
	    }

	    cov_1sttxmfv13.s[76]++;

	    if (visible === true) {
	      cov_1sttxmfv13.b[14][0]++;
	      cov_1sttxmfv13.s[77]++;
	      this.show();
	    } else {
	      cov_1sttxmfv13.b[14][1]++;
	    }

	    cov_1sttxmfv13.s[78]++;

	    if (visible === false) {
	      cov_1sttxmfv13.b[15][0]++;
	      cov_1sttxmfv13.s[79]++;
	      this.hide();
	    } else {
	      cov_1sttxmfv13.b[15][1]++;
	    }

	    cov_1sttxmfv13.s[80]++;

	    if (time > -1) {
	      cov_1sttxmfv13.b[16][0]++;
	      cov_1sttxmfv13.s[81]++;
	      this.timeUpdate(time);
	    } else {
	      cov_1sttxmfv13.b[16][1]++;
	    }

	    cov_1sttxmfv13.s[82]++;
	    this.preloadState_ = createDefaultPreloadState();
	  };

	  createClass(PtvEmbed, [{
	    key: "callbacks",
	    get: function get() {
	      cov_1sttxmfv13.f[5]++;
	      cov_1sttxmfv13.s[21]++;
	      return this.callbacks_;
	    }
	  }, {
	    key: "el",
	    get: function get() {
	      cov_1sttxmfv13.f[6]++;
	      cov_1sttxmfv13.s[22]++;
	      return this.el_;
	    }
	  }, {
	    key: "origin",
	    get: function get() {
	      cov_1sttxmfv13.f[7]++;
	      cov_1sttxmfv13.s[23]++;
	      return this.origin_;
	    }
	  }]);

	  return PtvEmbed;
	}();

	var config = {
	  // Test channel and stream
	  apiHost: ApiHosts.PRODUCTION,
	  embedHost: iframeMarkup,
	  channelId: '5c701be7dc3d20080e4092f4',
	  streamId: '5de7e7c2a6adde5211684519',
	  debug: true
	};
	/**
	 * Performs an asynchronous test for the API on the videojs-ptv host iframe
	 * Each public API method is called before the iframe target has loaded.
	 * The tests then wait for the (mock) iframe target to echo the message that
	 * it received (via its own `window.onmessage`) back to the host window for
	 * test assertions.
	 * Messages are echoed back to the host window via a function assigned to
	 * window[PTV_TEST_CALLBACK] on the host's Window object.
	 *
	 * This allows the following tests to assert the expected behaviour of the
	 * preload state mechanism of the PtvEmbed which tries to ensure that any
	 * API methods called before the SDK has loaded are then correctly applied to
	 * the SDK once it ready.
	 */

	QUnit__default['default'].module('communication with target iframe', function (hooks) {
	  var assignIframeSource_;
	  var getOrigin_;
	  hooks.before(function () {
	    // Store initial implementations of functions so that that they can be
	    // re-assigned once these tests are complete
	    assignIframeSource_ = PtvEmbed.assignIframeSource;
	    getOrigin_ = PtvEmbed.getOrigin; // Override `assignIframeSource` so that we can load our test iframe content.

	    PtvEmbed.assignIframeSource = function (el) {
	      return el.setAttribute('srcdoc', iframeMarkup);
	    }; // Override `getOrigin` so that we can set the correct origin for iframe test target,
	    // this should match the origin of the test runner


	    PtvEmbed.getOrigin = function () {
	      return 'http://localhost:9999';
	    };
	  });
	  hooks.beforeEach(function () {
	    var _this = this;

	    return new Promise(function (resolve, _) {
	      _this.fixture = document_1.getElementById('qunit-fixture');
	      _this.video = document_1.createElement('video');

	      _this.fixture.appendChild(_this.video);

	      _this.player = videojs__default['default'](_this.video);
	      _this.ptv = _this.player.ptv(config);

	      _this.player.ready(function () {
	        return resolve();
	      });
	    });
	  });
	  hooks.afterEach(function () {
	    this.ptv.dispose();
	  });
	  hooks.after(function () {
	    delete window_1[PTV_TEST_CALLBACK];
	    PtvEmbed.assignIframeSource = assignIframeSource_;
	    PtvEmbed.getOrigin = getOrigin_;
	  });

	  var testFactory = function testFactory(apiMethod, apiArgs) {
	    return function (assert) {
	      var done = assert.async(1);

	      window_1[PTV_TEST_CALLBACK] = function (payload) {
	        var method = payload.method,
	            value = payload.value;
	        assert.equal(apiMethod, method, "iframe received " + method);
	        assert.equal(JSON.stringify(value), JSON.stringify(apiArgs), method + " payload data is correct ");
	        done();
	      };

	      this.ptv[apiMethod](apiArgs);
	    };
	  };

	  QUnit__default['default'].test('ptv.hide() posts correct postMessage', testFactory('hide'));
	  QUnit__default['default'].test('ptv.load() posts correct postMessage', testFactory('load', {
	    channelId: 'test-channel'
	  }));
	  QUnit__default['default'].test('ptv.show() posts correct postMessage', testFactory('show'));
	  QUnit__default['default'].test('ptv.start() posts correct postMessage', testFactory('start'));
	  QUnit__default['default'].test('ptv.stop() posts correct postMessage', testFactory('stop'));
	  QUnit__default['default'].test('ptv.timeUpdate() posts correct postMessage', testFactory('timeUpdate', 0));
	});

	var _extends_1 = createCommonjsModule(function (module) {
	  function _extends() {
	    module.exports = _extends = Object.assign || function (target) {
	      for (var i = 1; i < arguments.length; i++) {
	        var source = arguments[i];

	        for (var key in source) {
	          if (Object.prototype.hasOwnProperty.call(source, key)) {
	            target[key] = source[key];
	          }
	        }
	      }

	      return target;
	    };

	    return _extends.apply(this, arguments);
	  }

	  module.exports = _extends;
	});

	function _assertThisInitialized(self) {
	  if (self === void 0) {
	    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
	  }

	  return self;
	}

	var assertThisInitialized = _assertThisInitialized;

	function _inheritsLoose(subClass, superClass) {
	  subClass.prototype = Object.create(superClass.prototype);
	  subClass.prototype.constructor = subClass;
	  subClass.__proto__ = superClass;
	}

	var inheritsLoose = _inheritsLoose;

	var version = "1.5.0";

	var cov_1wba2voqbv = function () {
	  var path = '/home/runner/work/videojs-ptv/videojs-ptv/src/plugin.js',
	      hash = 'c1e59c642105f0a3a3cd8637423c1f1e69ec9c6e',
	      Function = function () {}.constructor,
	      global = new Function('return this')(),
	      gcv = '__coverage__',
	      coverageData = {
	    path: '/home/runner/work/videojs-ptv/videojs-ptv/src/plugin.js',
	    statementMap: {
	      '0': {
	        start: {
	          line: 14,
	          column: 15
	        },
	        end: {
	          line: 14,
	          column: 42
	        }
	      },
	      '1': {
	        start: {
	          line: 17,
	          column: 17
	        },
	        end: {
	          line: 34,
	          column: 1
	        }
	      },
	      '2': {
	        start: {
	          line: 36,
	          column: 21
	        },
	        end: {
	          line: 39,
	          column: 1
	        }
	      },
	      '3': {
	        start: {
	          line: 62,
	          column: 4
	        },
	        end: {
	          line: 62,
	          column: 18
	        }
	      },
	      '4': {
	        start: {
	          line: 64,
	          column: 4
	        },
	        end: {
	          line: 64,
	          column: 32
	        }
	      },
	      '5': {
	        start: {
	          line: 66,
	          column: 4
	        },
	        end: {
	          line: 66,
	          column: 59
	        }
	      },
	      '6': {
	        start: {
	          line: 69,
	          column: 4
	        },
	        end: {
	          line: 69,
	          column: 58
	        }
	      },
	      '7': {
	        start: {
	          line: 76,
	          column: 22
	        },
	        end: {
	          line: 80,
	          column: 5
	        }
	      },
	      '8': {
	        start: {
	          line: 82,
	          column: 4
	        },
	        end: {
	          line: 82,
	          column: 36
	        }
	      },
	      '9': {
	        start: {
	          line: 85,
	          column: 4
	        },
	        end: {
	          line: 85,
	          column: 55
	        }
	      },
	      '10': {
	        start: {
	          line: 88,
	          column: 4
	        },
	        end: {
	          line: 88,
	          column: 31
	        }
	      },
	      '11': {
	        start: {
	          line: 91,
	          column: 4
	        },
	        end: {
	          line: 91,
	          column: 55
	        }
	      },
	      '12': {
	        start: {
	          line: 99,
	          column: 4
	        },
	        end: {
	          line: 101,
	          column: 5
	        }
	      },
	      '13': {
	        start: {
	          line: 100,
	          column: 6
	        },
	        end: {
	          line: 100,
	          column: 25
	        }
	      },
	      '14': {
	        start: {
	          line: 108,
	          column: 4
	        },
	        end: {
	          line: 108,
	          column: 43
	        }
	      },
	      '15': {
	        start: {
	          line: 110,
	          column: 4
	        },
	        end: {
	          line: 112,
	          column: 5
	        }
	      },
	      '16': {
	        start: {
	          line: 111,
	          column: 6
	        },
	        end: {
	          line: 111,
	          column: 27
	        }
	      },
	      '17': {
	        start: {
	          line: 124,
	          column: 4
	        },
	        end: {
	          line: 124,
	          column: 41
	        }
	      },
	      '18': {
	        start: {
	          line: 127,
	          column: 4
	        },
	        end: {
	          line: 129,
	          column: 5
	        }
	      },
	      '19': {
	        start: {
	          line: 128,
	          column: 6
	        },
	        end: {
	          line: 128,
	          column: 19
	        }
	      },
	      '20': {
	        start: {
	          line: 132,
	          column: 4
	        },
	        end: {
	          line: 134,
	          column: 5
	        }
	      },
	      '21': {
	        start: {
	          line: 133,
	          column: 6
	        },
	        end: {
	          line: 133,
	          column: 41
	        }
	      },
	      '22': {
	        start: {
	          line: 137,
	          column: 4
	        },
	        end: {
	          line: 139,
	          column: 5
	        }
	      },
	      '23': {
	        start: {
	          line: 138,
	          column: 6
	        },
	        end: {
	          line: 138,
	          column: 27
	        }
	      },
	      '24': {
	        start: {
	          line: 147,
	          column: 4
	        },
	        end: {
	          line: 151,
	          column: 5
	        }
	      },
	      '25': {
	        start: {
	          line: 148,
	          column: 6
	        },
	        end: {
	          line: 148,
	          column: 25
	        }
	      },
	      '26': {
	        start: {
	          line: 150,
	          column: 6
	        },
	        end: {
	          line: 150,
	          column: 26
	        }
	      },
	      '27': {
	        start: {
	          line: 158,
	          column: 4
	        },
	        end: {
	          line: 160,
	          column: 5
	        }
	      },
	      '28': {
	        start: {
	          line: 159,
	          column: 6
	        },
	        end: {
	          line: 159,
	          column: 13
	        }
	      },
	      '29': {
	        start: {
	          line: 161,
	          column: 4
	        },
	        end: {
	          line: 161,
	          column: 62
	        }
	      },
	      '30': {
	        start: {
	          line: 161,
	          column: 48
	        },
	        end: {
	          line: 161,
	          column: 60
	        }
	      },
	      '31': {
	        start: {
	          line: 162,
	          column: 4
	        },
	        end: {
	          line: 162,
	          column: 58
	        }
	      },
	      '32': {
	        start: {
	          line: 162,
	          column: 45
	        },
	        end: {
	          line: 162,
	          column: 56
	        }
	      },
	      '33': {
	        start: {
	          line: 163,
	          column: 4
	        },
	        end: {
	          line: 163,
	          column: 58
	        }
	      },
	      '34': {
	        start: {
	          line: 163,
	          column: 45
	        },
	        end: {
	          line: 163,
	          column: 56
	        }
	      },
	      '35': {
	        start: {
	          line: 164,
	          column: 4
	        },
	        end: {
	          line: 164,
	          column: 58
	        }
	      },
	      '36': {
	        start: {
	          line: 164,
	          column: 45
	        },
	        end: {
	          line: 164,
	          column: 56
	        }
	      },
	      '37': {
	        start: {
	          line: 165,
	          column: 4
	        },
	        end: {
	          line: 165,
	          column: 57
	        }
	      },
	      '38': {
	        start: {
	          line: 165,
	          column: 44
	        },
	        end: {
	          line: 165,
	          column: 55
	        }
	      },
	      '39': {
	        start: {
	          line: 166,
	          column: 4
	        },
	        end: {
	          line: 167,
	          column: 50
	        }
	      },
	      '40': {
	        start: {
	          line: 167,
	          column: 6
	        },
	        end: {
	          line: 167,
	          column: 48
	        }
	      },
	      '41': {
	        start: {
	          line: 174,
	          column: 4
	        },
	        end: {
	          line: 176,
	          column: 5
	        }
	      },
	      '42': {
	        start: {
	          line: 175,
	          column: 6
	        },
	        end: {
	          line: 175,
	          column: 13
	        }
	      },
	      '43': {
	        start: {
	          line: 177,
	          column: 4
	        },
	        end: {
	          line: 184,
	          column: 7
	        }
	      },
	      '44': {
	        start: {
	          line: 191,
	          column: 4
	        },
	        end: {
	          line: 191,
	          column: 34
	        }
	      },
	      '45': {
	        start: {
	          line: 192,
	          column: 4
	        },
	        end: {
	          line: 194,
	          column: 5
	        }
	      },
	      '46': {
	        start: {
	          line: 193,
	          column: 6
	        },
	        end: {
	          line: 193,
	          column: 27
	        }
	      },
	      '47': {
	        start: {
	          line: 195,
	          column: 4
	        },
	        end: {
	          line: 195,
	          column: 20
	        }
	      },
	      '48': {
	        start: {
	          line: 207,
	          column: 4
	        },
	        end: {
	          line: 209,
	          column: 5
	        }
	      },
	      '49': {
	        start: {
	          line: 208,
	          column: 6
	        },
	        end: {
	          line: 208,
	          column: 24
	        }
	      },
	      '50': {
	        start: {
	          line: 218,
	          column: 4
	        },
	        end: {
	          line: 218,
	          column: 32
	        }
	      },
	      '51': {
	        start: {
	          line: 220,
	          column: 4
	        },
	        end: {
	          line: 222,
	          column: 5
	        }
	      },
	      '52': {
	        start: {
	          line: 221,
	          column: 6
	        },
	        end: {
	          line: 221,
	          column: 30
	        }
	      },
	      '53': {
	        start: {
	          line: 229,
	          column: 4
	        },
	        end: {
	          line: 231,
	          column: 5
	        }
	      },
	      '54': {
	        start: {
	          line: 230,
	          column: 6
	        },
	        end: {
	          line: 230,
	          column: 24
	        }
	      },
	      '55': {
	        start: {
	          line: 238,
	          column: 4
	        },
	        end: {
	          line: 240,
	          column: 5
	        }
	      },
	      '56': {
	        start: {
	          line: 239,
	          column: 6
	        },
	        end: {
	          line: 239,
	          column: 25
	        }
	      },
	      '57': {
	        start: {
	          line: 247,
	          column: 4
	        },
	        end: {
	          line: 249,
	          column: 5
	        }
	      },
	      '58': {
	        start: {
	          line: 248,
	          column: 6
	        },
	        end: {
	          line: 248,
	          column: 24
	        }
	      },
	      '59': {
	        start: {
	          line: 258,
	          column: 4
	        },
	        end: {
	          line: 260,
	          column: 5
	        }
	      },
	      '60': {
	        start: {
	          line: 259,
	          column: 6
	        },
	        end: {
	          line: 259,
	          column: 37
	        }
	      },
	      '61': {
	        start: {
	          line: 265,
	          column: 0
	        },
	        end: {
	          line: 265,
	          column: 32
	        }
	      },
	      '62': {
	        start: {
	          line: 268,
	          column: 0
	        },
	        end: {
	          line: 268,
	          column: 22
	        }
	      },
	      '63': {
	        start: {
	          line: 271,
	          column: 0
	        },
	        end: {
	          line: 271,
	          column: 35
	        }
	      },
	      '64': {
	        start: {
	          line: 274,
	          column: 25
	        },
	        end: {
	          line: 279,
	          column: 1
	        }
	      }
	    },
	    fnMap: {
	      '0': {
	        name: '(anonymous_0)',
	        decl: {
	          start: {
	            line: 60,
	            column: 2
	          },
	          end: {
	            line: 60,
	            column: 3
	          }
	        },
	        loc: {
	          start: {
	            line: 60,
	            column: 31
	          },
	          end: {
	            line: 70,
	            column: 3
	          }
	        },
	        line: 60
	      },
	      '1': {
	        name: '(anonymous_1)',
	        decl: {
	          start: {
	            line: 75,
	            column: 2
	          },
	          end: {
	            line: 75,
	            column: 3
	          }
	        },
	        loc: {
	          start: {
	            line: 75,
	            column: 23
	          },
	          end: {
	            line: 92,
	            column: 3
	          }
	        },
	        line: 75
	      },
	      '2': {
	        name: '(anonymous_2)',
	        decl: {
	          start: {
	            line: 98,
	            column: 2
	          },
	          end: {
	            line: 98,
	            column: 3
	          }
	        },
	        loc: {
	          start: {
	            line: 98,
	            column: 21
	          },
	          end: {
	            line: 102,
	            column: 3
	          }
	        },
	        line: 98
	      },
	      '3': {
	        name: '(anonymous_3)',
	        decl: {
	          start: {
	            line: 107,
	            column: 2
	          },
	          end: {
	            line: 107,
	            column: 3
	          }
	        },
	        loc: {
	          start: {
	            line: 107,
	            column: 25
	          },
	          end: {
	            line: 113,
	            column: 3
	          }
	        },
	        line: 107
	      },
	      '4': {
	        name: '(anonymous_4)',
	        decl: {
	          start: {
	            line: 123,
	            column: 2
	          },
	          end: {
	            line: 123,
	            column: 3
	          }
	        },
	        loc: {
	          start: {
	            line: 123,
	            column: 44
	          },
	          end: {
	            line: 140,
	            column: 3
	          }
	        },
	        line: 123
	      },
	      '5': {
	        name: '(anonymous_5)',
	        decl: {
	          start: {
	            line: 146,
	            column: 2
	          },
	          end: {
	            line: 146,
	            column: 3
	          }
	        },
	        loc: {
	          start: {
	            line: 146,
	            column: 16
	          },
	          end: {
	            line: 152,
	            column: 3
	          }
	        },
	        line: 146
	      },
	      '6': {
	        name: '(anonymous_6)',
	        decl: {
	          start: {
	            line: 157,
	            column: 2
	          },
	          end: {
	            line: 157,
	            column: 3
	          }
	        },
	        loc: {
	          start: {
	            line: 157,
	            column: 24
	          },
	          end: {
	            line: 168,
	            column: 3
	          }
	        },
	        line: 157
	      },
	      '7': {
	        name: '(anonymous_7)',
	        decl: {
	          start: {
	            line: 161,
	            column: 42
	          },
	          end: {
	            line: 161,
	            column: 43
	          }
	        },
	        loc: {
	          start: {
	            line: 161,
	            column: 48
	          },
	          end: {
	            line: 161,
	            column: 60
	          }
	        },
	        line: 161
	      },
	      '8': {
	        name: '(anonymous_8)',
	        decl: {
	          start: {
	            line: 162,
	            column: 39
	          },
	          end: {
	            line: 162,
	            column: 40
	          }
	        },
	        loc: {
	          start: {
	            line: 162,
	            column: 45
	          },
	          end: {
	            line: 162,
	            column: 56
	          }
	        },
	        line: 162
	      },
	      '9': {
	        name: '(anonymous_9)',
	        decl: {
	          start: {
	            line: 163,
	            column: 39
	          },
	          end: {
	            line: 163,
	            column: 40
	          }
	        },
	        loc: {
	          start: {
	            line: 163,
	            column: 45
	          },
	          end: {
	            line: 163,
	            column: 56
	          }
	        },
	        line: 163
	      },
	      '10': {
	        name: '(anonymous_10)',
	        decl: {
	          start: {
	            line: 164,
	            column: 39
	          },
	          end: {
	            line: 164,
	            column: 40
	          }
	        },
	        loc: {
	          start: {
	            line: 164,
	            column: 45
	          },
	          end: {
	            line: 164,
	            column: 56
	          }
	        },
	        line: 164
	      },
	      '11': {
	        name: '(anonymous_11)',
	        decl: {
	          start: {
	            line: 165,
	            column: 38
	          },
	          end: {
	            line: 165,
	            column: 39
	          }
	        },
	        loc: {
	          start: {
	            line: 165,
	            column: 44
	          },
	          end: {
	            line: 165,
	            column: 55
	          }
	        },
	        line: 165
	      },
	      '12': {
	        name: '(anonymous_12)',
	        decl: {
	          start: {
	            line: 166,
	            column: 45
	          },
	          end: {
	            line: 166,
	            column: 46
	          }
	        },
	        loc: {
	          start: {
	            line: 167,
	            column: 6
	          },
	          end: {
	            line: 167,
	            column: 48
	          }
	        },
	        line: 167
	      },
	      '13': {
	        name: '(anonymous_13)',
	        decl: {
	          start: {
	            line: 173,
	            column: 2
	          },
	          end: {
	            line: 173,
	            column: 3
	          }
	        },
	        loc: {
	          start: {
	            line: 173,
	            column: 27
	          },
	          end: {
	            line: 185,
	            column: 3
	          }
	        },
	        line: 173
	      },
	      '14': {
	        name: '(anonymous_14)',
	        decl: {
	          start: {
	            line: 190,
	            column: 2
	          },
	          end: {
	            line: 190,
	            column: 3
	          }
	        },
	        loc: {
	          start: {
	            line: 190,
	            column: 12
	          },
	          end: {
	            line: 196,
	            column: 3
	          }
	        },
	        line: 190
	      },
	      '15': {
	        name: '(anonymous_15)',
	        decl: {
	          start: {
	            line: 206,
	            column: 2
	          },
	          end: {
	            line: 206,
	            column: 3
	          }
	        },
	        loc: {
	          start: {
	            line: 206,
	            column: 9
	          },
	          end: {
	            line: 210,
	            column: 3
	          }
	        },
	        line: 206
	      },
	      '16': {
	        name: '(anonymous_16)',
	        decl: {
	          start: {
	            line: 217,
	            column: 2
	          },
	          end: {
	            line: 217,
	            column: 3
	          }
	        },
	        loc: {
	          start: {
	            line: 217,
	            column: 15
	          },
	          end: {
	            line: 223,
	            column: 3
	          }
	        },
	        line: 217
	      },
	      '17': {
	        name: '(anonymous_17)',
	        decl: {
	          start: {
	            line: 228,
	            column: 2
	          },
	          end: {
	            line: 228,
	            column: 3
	          }
	        },
	        loc: {
	          start: {
	            line: 228,
	            column: 9
	          },
	          end: {
	            line: 232,
	            column: 3
	          }
	        },
	        line: 228
	      },
	      '18': {
	        name: '(anonymous_18)',
	        decl: {
	          start: {
	            line: 237,
	            column: 2
	          },
	          end: {
	            line: 237,
	            column: 3
	          }
	        },
	        loc: {
	          start: {
	            line: 237,
	            column: 10
	          },
	          end: {
	            line: 241,
	            column: 3
	          }
	        },
	        line: 237
	      },
	      '19': {
	        name: '(anonymous_19)',
	        decl: {
	          start: {
	            line: 246,
	            column: 2
	          },
	          end: {
	            line: 246,
	            column: 3
	          }
	        },
	        loc: {
	          start: {
	            line: 246,
	            column: 9
	          },
	          end: {
	            line: 250,
	            column: 3
	          }
	        },
	        line: 246
	      },
	      '20': {
	        name: '(anonymous_20)',
	        decl: {
	          start: {
	            line: 257,
	            column: 2
	          },
	          end: {
	            line: 257,
	            column: 3
	          }
	        },
	        loc: {
	          start: {
	            line: 257,
	            column: 22
	          },
	          end: {
	            line: 261,
	            column: 3
	          }
	        },
	        line: 257
	      }
	    },
	    branchMap: {
	      '0': {
	        loc: {
	          start: {
	            line: 99,
	            column: 4
	          },
	          end: {
	            line: 101,
	            column: 5
	          }
	        },
	        type: 'if',
	        locations: [{
	          start: {
	            line: 99,
	            column: 4
	          },
	          end: {
	            line: 101,
	            column: 5
	          }
	        }, {
	          start: {
	            line: 99,
	            column: 4
	          },
	          end: {
	            line: 101,
	            column: 5
	          }
	        }],
	        line: 99
	      },
	      '1': {
	        loc: {
	          start: {
	            line: 99,
	            column: 8
	          },
	          end: {
	            line: 99,
	            column: 71
	          }
	        },
	        type: 'binary-expr',
	        locations: [{
	          start: {
	            line: 99,
	            column: 8
	          },
	          end: {
	            line: 99,
	            column: 33
	          }
	        }, {
	          start: {
	            line: 99,
	            column: 37
	          },
	          end: {
	            line: 99,
	            column: 71
	          }
	        }],
	        line: 99
	      },
	      '2': {
	        loc: {
	          start: {
	            line: 110,
	            column: 4
	          },
	          end: {
	            line: 112,
	            column: 5
	          }
	        },
	        type: 'if',
	        locations: [{
	          start: {
	            line: 110,
	            column: 4
	          },
	          end: {
	            line: 112,
	            column: 5
	          }
	        }, {
	          start: {
	            line: 110,
	            column: 4
	          },
	          end: {
	            line: 112,
	            column: 5
	          }
	        }],
	        line: 110
	      },
	      '3': {
	        loc: {
	          start: {
	            line: 127,
	            column: 4
	          },
	          end: {
	            line: 129,
	            column: 5
	          }
	        },
	        type: 'if',
	        locations: [{
	          start: {
	            line: 127,
	            column: 4
	          },
	          end: {
	            line: 129,
	            column: 5
	          }
	        }, {
	          start: {
	            line: 127,
	            column: 4
	          },
	          end: {
	            line: 129,
	            column: 5
	          }
	        }],
	        line: 127
	      },
	      '4': {
	        loc: {
	          start: {
	            line: 132,
	            column: 4
	          },
	          end: {
	            line: 134,
	            column: 5
	          }
	        },
	        type: 'if',
	        locations: [{
	          start: {
	            line: 132,
	            column: 4
	          },
	          end: {
	            line: 134,
	            column: 5
	          }
	        }, {
	          start: {
	            line: 132,
	            column: 4
	          },
	          end: {
	            line: 134,
	            column: 5
	          }
	        }],
	        line: 132
	      },
	      '5': {
	        loc: {
	          start: {
	            line: 132,
	            column: 8
	          },
	          end: {
	            line: 132,
	            column: 61
	          }
	        },
	        type: 'binary-expr',
	        locations: [{
	          start: {
	            line: 132,
	            column: 8
	          },
	          end: {
	            line: 132,
	            column: 31
	          }
	        }, {
	          start: {
	            line: 132,
	            column: 35
	          },
	          end: {
	            line: 132,
	            column: 61
	          }
	        }],
	        line: 132
	      },
	      '6': {
	        loc: {
	          start: {
	            line: 137,
	            column: 4
	          },
	          end: {
	            line: 139,
	            column: 5
	          }
	        },
	        type: 'if',
	        locations: [{
	          start: {
	            line: 137,
	            column: 4
	          },
	          end: {
	            line: 139,
	            column: 5
	          }
	        }, {
	          start: {
	            line: 137,
	            column: 4
	          },
	          end: {
	            line: 139,
	            column: 5
	          }
	        }],
	        line: 137
	      },
	      '7': {
	        loc: {
	          start: {
	            line: 137,
	            column: 8
	          },
	          end: {
	            line: 137,
	            column: 59
	          }
	        },
	        type: 'binary-expr',
	        locations: [{
	          start: {
	            line: 137,
	            column: 8
	          },
	          end: {
	            line: 137,
	            column: 26
	          }
	        }, {
	          start: {
	            line: 137,
	            column: 30
	          },
	          end: {
	            line: 137,
	            column: 59
	          }
	        }],
	        line: 137
	      },
	      '8': {
	        loc: {
	          start: {
	            line: 147,
	            column: 4
	          },
	          end: {
	            line: 151,
	            column: 5
	          }
	        },
	        type: 'if',
	        locations: [{
	          start: {
	            line: 147,
	            column: 4
	          },
	          end: {
	            line: 151,
	            column: 5
	          }
	        }, {
	          start: {
	            line: 147,
	            column: 4
	          },
	          end: {
	            line: 151,
	            column: 5
	          }
	        }],
	        line: 147
	      },
	      '9': {
	        loc: {
	          start: {
	            line: 158,
	            column: 4
	          },
	          end: {
	            line: 160,
	            column: 5
	          }
	        },
	        type: 'if',
	        locations: [{
	          start: {
	            line: 158,
	            column: 4
	          },
	          end: {
	            line: 160,
	            column: 5
	          }
	        }, {
	          start: {
	            line: 158,
	            column: 4
	          },
	          end: {
	            line: 160,
	            column: 5
	          }
	        }],
	        line: 158
	      },
	      '10': {
	        loc: {
	          start: {
	            line: 174,
	            column: 4
	          },
	          end: {
	            line: 176,
	            column: 5
	          }
	        },
	        type: 'if',
	        locations: [{
	          start: {
	            line: 174,
	            column: 4
	          },
	          end: {
	            line: 176,
	            column: 5
	          }
	        }, {
	          start: {
	            line: 174,
	            column: 4
	          },
	          end: {
	            line: 176,
	            column: 5
	          }
	        }],
	        line: 174
	      },
	      '11': {
	        loc: {
	          start: {
	            line: 192,
	            column: 4
	          },
	          end: {
	            line: 194,
	            column: 5
	          }
	        },
	        type: 'if',
	        locations: [{
	          start: {
	            line: 192,
	            column: 4
	          },
	          end: {
	            line: 194,
	            column: 5
	          }
	        }, {
	          start: {
	            line: 192,
	            column: 4
	          },
	          end: {
	            line: 194,
	            column: 5
	          }
	        }],
	        line: 192
	      },
	      '12': {
	        loc: {
	          start: {
	            line: 207,
	            column: 4
	          },
	          end: {
	            line: 209,
	            column: 5
	          }
	        },
	        type: 'if',
	        locations: [{
	          start: {
	            line: 207,
	            column: 4
	          },
	          end: {
	            line: 209,
	            column: 5
	          }
	        }, {
	          start: {
	            line: 207,
	            column: 4
	          },
	          end: {
	            line: 209,
	            column: 5
	          }
	        }],
	        line: 207
	      },
	      '13': {
	        loc: {
	          start: {
	            line: 220,
	            column: 4
	          },
	          end: {
	            line: 222,
	            column: 5
	          }
	        },
	        type: 'if',
	        locations: [{
	          start: {
	            line: 220,
	            column: 4
	          },
	          end: {
	            line: 222,
	            column: 5
	          }
	        }, {
	          start: {
	            line: 220,
	            column: 4
	          },
	          end: {
	            line: 222,
	            column: 5
	          }
	        }],
	        line: 220
	      },
	      '14': {
	        loc: {
	          start: {
	            line: 229,
	            column: 4
	          },
	          end: {
	            line: 231,
	            column: 5
	          }
	        },
	        type: 'if',
	        locations: [{
	          start: {
	            line: 229,
	            column: 4
	          },
	          end: {
	            line: 231,
	            column: 5
	          }
	        }, {
	          start: {
	            line: 229,
	            column: 4
	          },
	          end: {
	            line: 231,
	            column: 5
	          }
	        }],
	        line: 229
	      },
	      '15': {
	        loc: {
	          start: {
	            line: 238,
	            column: 4
	          },
	          end: {
	            line: 240,
	            column: 5
	          }
	        },
	        type: 'if',
	        locations: [{
	          start: {
	            line: 238,
	            column: 4
	          },
	          end: {
	            line: 240,
	            column: 5
	          }
	        }, {
	          start: {
	            line: 238,
	            column: 4
	          },
	          end: {
	            line: 240,
	            column: 5
	          }
	        }],
	        line: 238
	      },
	      '16': {
	        loc: {
	          start: {
	            line: 247,
	            column: 4
	          },
	          end: {
	            line: 249,
	            column: 5
	          }
	        },
	        type: 'if',
	        locations: [{
	          start: {
	            line: 247,
	            column: 4
	          },
	          end: {
	            line: 249,
	            column: 5
	          }
	        }, {
	          start: {
	            line: 247,
	            column: 4
	          },
	          end: {
	            line: 249,
	            column: 5
	          }
	        }],
	        line: 247
	      },
	      '17': {
	        loc: {
	          start: {
	            line: 258,
	            column: 4
	          },
	          end: {
	            line: 260,
	            column: 5
	          }
	        },
	        type: 'if',
	        locations: [{
	          start: {
	            line: 258,
	            column: 4
	          },
	          end: {
	            line: 260,
	            column: 5
	          }
	        }, {
	          start: {
	            line: 258,
	            column: 4
	          },
	          end: {
	            line: 260,
	            column: 5
	          }
	        }],
	        line: 258
	      }
	    },
	    s: {
	      '0': 0,
	      '1': 0,
	      '2': 0,
	      '3': 0,
	      '4': 0,
	      '5': 0,
	      '6': 0,
	      '7': 0,
	      '8': 0,
	      '9': 0,
	      '10': 0,
	      '11': 0,
	      '12': 0,
	      '13': 0,
	      '14': 0,
	      '15': 0,
	      '16': 0,
	      '17': 0,
	      '18': 0,
	      '19': 0,
	      '20': 0,
	      '21': 0,
	      '22': 0,
	      '23': 0,
	      '24': 0,
	      '25': 0,
	      '26': 0,
	      '27': 0,
	      '28': 0,
	      '29': 0,
	      '30': 0,
	      '31': 0,
	      '32': 0,
	      '33': 0,
	      '34': 0,
	      '35': 0,
	      '36': 0,
	      '37': 0,
	      '38': 0,
	      '39': 0,
	      '40': 0,
	      '41': 0,
	      '42': 0,
	      '43': 0,
	      '44': 0,
	      '45': 0,
	      '46': 0,
	      '47': 0,
	      '48': 0,
	      '49': 0,
	      '50': 0,
	      '51': 0,
	      '52': 0,
	      '53': 0,
	      '54': 0,
	      '55': 0,
	      '56': 0,
	      '57': 0,
	      '58': 0,
	      '59': 0,
	      '60': 0,
	      '61': 0,
	      '62': 0,
	      '63': 0,
	      '64': 0
	    },
	    f: {
	      '0': 0,
	      '1': 0,
	      '2': 0,
	      '3': 0,
	      '4': 0,
	      '5': 0,
	      '6': 0,
	      '7': 0,
	      '8': 0,
	      '9': 0,
	      '10': 0,
	      '11': 0,
	      '12': 0,
	      '13': 0,
	      '14': 0,
	      '15': 0,
	      '16': 0,
	      '17': 0,
	      '18': 0,
	      '19': 0,
	      '20': 0
	    },
	    b: {
	      '0': [0, 0],
	      '1': [0, 0],
	      '2': [0, 0],
	      '3': [0, 0],
	      '4': [0, 0],
	      '5': [0, 0],
	      '6': [0, 0],
	      '7': [0, 0],
	      '8': [0, 0],
	      '9': [0, 0],
	      '10': [0, 0],
	      '11': [0, 0],
	      '12': [0, 0],
	      '13': [0, 0],
	      '14': [0, 0],
	      '15': [0, 0],
	      '16': [0, 0],
	      '17': [0, 0]
	    },
	    _coverageSchema: '332fd63041d2c1bcb487cc26dd0d5f7d97098a6c'
	  },
	      coverage = global[gcv] || (global[gcv] = {});

	  if (coverage[path] && coverage[path].hash === hash) {
	    return coverage[path];
	  }

	  coverageData.hash = hash;
	  return coverage[path] = coverageData;
	}();
	var Plugin = (cov_1wba2voqbv.s[0]++, videojs__default['default'].getPlugin('plugin'));
	var defaults = (cov_1wba2voqbv.s[1]++, {
	  apiHost: ApiHosts.PRODUCTION,
	  autoWireEvents: true,
	  channelId: null,
	  debug: false,
	  enableGeoBlock: false,
	  embedHost: EmbedHosts.PRODUCTION,
	  platformId: null,
	  platformName: null,
	  platformType: null,
	  previewMode: false,
	  showDebugPanel: false,
	  showPoster: false,
	  streamId: null,
	  viewerId: null,
	  viewerLatitude: null,
	  viewerLongitude: null
	});
	var defaultState = (cov_1wba2voqbv.s[2]++, {
	  configReady: false,
	  configFailure: false
	});

	var Ptv = /*#__PURE__*/function (_Plugin) {
	  inheritsLoose(Ptv, _Plugin);

	  function Ptv(player, options) {
	    var _this;

	    cov_1wba2voqbv.f[0]++;
	    cov_1wba2voqbv.s[3]++;
	    _this = _Plugin.call(this, player) || this;
	    cov_1wba2voqbv.s[4]++;

	    _this.setState(defaultState);

	    cov_1wba2voqbv.s[5]++;
	    _this.options = videojs__default['default'].mergeOptions(defaults, options);
	    cov_1wba2voqbv.s[6]++;

	    _this.player.ready(_this.handlePlayerReady_.bind(assertThisInitialized(_this)));

	    return _this;
	  }

	  var _proto = Ptv.prototype;

	  _proto.handlePlayerReady_ = function handlePlayerReady_() {
	    cov_1wba2voqbv.f[1]++;
	    var callbacks = (cov_1wba2voqbv.s[7]++, {
	      onClickMiss: this.handleClickMiss_.bind(this),
	      onConfigReady: this.handleConfigReady_.bind(this),
	      onConfigFailure: this.handleConfigFailure_.bind(this)
	    });
	    cov_1wba2voqbv.s[8]++;
	    this.player.addClass('vjs-ptv');
	    cov_1wba2voqbv.s[9]++;
	    this.embed = new PtvEmbed(this.options, callbacks);
	    cov_1wba2voqbv.s[10]++;
	    this.addPlayerListeners_();
	    cov_1wba2voqbv.s[11]++;
	    this.player.posterImage.el().before(this.embed.el);
	  };

	  _proto.handleClickMiss_ = function handleClickMiss_() {
	    cov_1wba2voqbv.f[2]++;
	    cov_1wba2voqbv.s[12]++;

	    if ((cov_1wba2voqbv.b[1][0]++, this.player.bigPlayButton) && (cov_1wba2voqbv.b[1][1]++, this.player.bigPlayButton.enabled_)) {
	      cov_1wba2voqbv.b[0][0]++;
	      cov_1wba2voqbv.s[13]++;
	      this.togglePlay_();
	    } else {
	      cov_1wba2voqbv.b[0][1]++;
	    }
	  };

	  _proto.handleConfigFailure_ = function handleConfigFailure_() {
	    cov_1wba2voqbv.f[3]++;
	    cov_1wba2voqbv.s[14]++;
	    this.setState({
	      configFailure: true
	    });
	    cov_1wba2voqbv.s[15]++;

	    if (this.embed) {
	      cov_1wba2voqbv.b[2][0]++;
	      cov_1wba2voqbv.s[16]++;
	      this.embed.destroy();
	    } else {
	      cov_1wba2voqbv.b[2][1]++;
	    }
	  };

	  _proto.handleConfigReady_ = function handleConfigReady_(_ref) {
	    var poster = _ref.poster,
	        src = _ref.src,
	        type = _ref.type;
	    cov_1wba2voqbv.f[4]++;
	    cov_1wba2voqbv.s[17]++;
	    this.setState({
	      configReady: true
	    });
	    cov_1wba2voqbv.s[18]++;

	    if (!this.player.paused()) {
	      cov_1wba2voqbv.b[3][0]++;
	      cov_1wba2voqbv.s[19]++;
	      this.start();
	    } else {
	      cov_1wba2voqbv.b[3][1]++;
	    }

	    cov_1wba2voqbv.s[20]++;

	    if ((cov_1wba2voqbv.b[5][0]++, this.options.showPoster) && (cov_1wba2voqbv.b[5][1]++, typeof poster === 'object')) {
	      cov_1wba2voqbv.b[4][0]++;
	      cov_1wba2voqbv.s[21]++;
	      this.player.poster(poster.loading);
	    } else {
	      cov_1wba2voqbv.b[4][1]++;
	    }

	    cov_1wba2voqbv.s[22]++;

	    if ((cov_1wba2voqbv.b[7][0]++, !this.player.src()) && (cov_1wba2voqbv.b[7][1]++, this.player.canPlayType(type))) {
	      cov_1wba2voqbv.b[6][0]++;
	      cov_1wba2voqbv.s[23]++;
	      this.player.src(src);
	    } else {
	      cov_1wba2voqbv.b[6][1]++;
	    }
	  };

	  _proto.togglePlay_ = function togglePlay_() {
	    cov_1wba2voqbv.f[5]++;
	    cov_1wba2voqbv.s[24]++;

	    if (this.player.paused()) {
	      cov_1wba2voqbv.b[8][0]++;
	      cov_1wba2voqbv.s[25]++;
	      this.player.play();
	    } else {
	      cov_1wba2voqbv.b[8][1]++;
	      cov_1wba2voqbv.s[26]++;
	      this.player.pause();
	    }
	  };

	  _proto.addPlayerListeners_ = function addPlayerListeners_() {
	    var _this2 = this;

	    cov_1wba2voqbv.f[6]++;
	    cov_1wba2voqbv.s[27]++;

	    if (!this.options.autoWireEvents) {
	      cov_1wba2voqbv.b[9][0]++;
	      cov_1wba2voqbv.s[28]++;
	      return;
	    } else {
	      cov_1wba2voqbv.b[9][1]++;
	    }

	    cov_1wba2voqbv.s[29]++;
	    this.player.one(PlayerEvents.PLAYING, function () {
	      cov_1wba2voqbv.f[7]++;
	      cov_1wba2voqbv.s[30]++;
	      return _this2.start();
	    });
	    cov_1wba2voqbv.s[31]++;
	    this.player.on(PlayerEvents.ENDED, function () {
	      cov_1wba2voqbv.f[8]++;
	      cov_1wba2voqbv.s[32]++;
	      return _this2.stop();
	    });
	    cov_1wba2voqbv.s[33]++;
	    this.player.on(PlayerEvents.ERROR, function () {
	      cov_1wba2voqbv.f[9]++;
	      cov_1wba2voqbv.s[34]++;
	      return _this2.stop();
	    });
	    cov_1wba2voqbv.s[35]++;
	    this.player.on(PlayerEvents.PAUSE, function () {
	      cov_1wba2voqbv.f[10]++;
	      cov_1wba2voqbv.s[36]++;
	      return _this2.hide();
	    });
	    cov_1wba2voqbv.s[37]++;
	    this.player.on(PlayerEvents.PLAY, function () {
	      cov_1wba2voqbv.f[11]++;
	      cov_1wba2voqbv.s[38]++;
	      return _this2.show();
	    });
	    cov_1wba2voqbv.s[39]++;
	    this.player.on(PlayerEvents.TIME_UPDATE, function () {
	      cov_1wba2voqbv.f[12]++;
	      cov_1wba2voqbv.s[40]++;
	      return _this2.timeUpdate(_this2.player.currentTime());
	    });
	  };

	  _proto.removePlayerListeners_ = function removePlayerListeners_() {
	    cov_1wba2voqbv.f[13]++;
	    cov_1wba2voqbv.s[41]++;

	    if (!this.options.autoWireEvents) {
	      cov_1wba2voqbv.b[10][0]++;
	      cov_1wba2voqbv.s[42]++;
	      return;
	    } else {
	      cov_1wba2voqbv.b[10][1]++;
	    }

	    cov_1wba2voqbv.s[43]++;
	    this.player.off([PlayerEvents.ENDED, PlayerEvents.ERROR, PlayerEvents.PAUSE, PlayerEvents.PLAY, PlayerEvents.PLAYING, PlayerEvents.TIME_UPDATE]);
	  };

	  _proto.dispose = function dispose() {
	    cov_1wba2voqbv.f[14]++;
	    cov_1wba2voqbv.s[44]++;
	    this.removePlayerListeners_();
	    cov_1wba2voqbv.s[45]++;

	    if (this.embed) {
	      cov_1wba2voqbv.b[11][0]++;
	      cov_1wba2voqbv.s[46]++;
	      this.embed.dispose();
	    } else {
	      cov_1wba2voqbv.b[11][1]++;
	    }

	    cov_1wba2voqbv.s[47]++;

	    _Plugin.prototype.dispose.call(this);
	  };

	  _proto.hide = function hide() {
	    cov_1wba2voqbv.f[15]++;
	    cov_1wba2voqbv.s[48]++;

	    if (this.embed) {
	      cov_1wba2voqbv.b[12][0]++;
	      cov_1wba2voqbv.s[49]++;
	      this.embed.hide();
	    } else {
	      cov_1wba2voqbv.b[12][1]++;
	    }
	  };

	  _proto.load = function load(config) {
	    cov_1wba2voqbv.f[16]++;
	    cov_1wba2voqbv.s[50]++;
	    this.setState(defaultState);
	    cov_1wba2voqbv.s[51]++;

	    if (this.embed) {
	      cov_1wba2voqbv.b[13][0]++;
	      cov_1wba2voqbv.s[52]++;
	      this.embed.load(config);
	    } else {
	      cov_1wba2voqbv.b[13][1]++;
	    }
	  };

	  _proto.show = function show() {
	    cov_1wba2voqbv.f[17]++;
	    cov_1wba2voqbv.s[53]++;

	    if (this.embed) {
	      cov_1wba2voqbv.b[14][0]++;
	      cov_1wba2voqbv.s[54]++;
	      this.embed.show();
	    } else {
	      cov_1wba2voqbv.b[14][1]++;
	    }
	  };

	  _proto.start = function start() {
	    cov_1wba2voqbv.f[18]++;
	    cov_1wba2voqbv.s[55]++;

	    if (this.embed) {
	      cov_1wba2voqbv.b[15][0]++;
	      cov_1wba2voqbv.s[56]++;
	      this.embed.start();
	    } else {
	      cov_1wba2voqbv.b[15][1]++;
	    }
	  };

	  _proto.stop = function stop() {
	    cov_1wba2voqbv.f[19]++;
	    cov_1wba2voqbv.s[57]++;

	    if (this.embed) {
	      cov_1wba2voqbv.b[16][0]++;
	      cov_1wba2voqbv.s[58]++;
	      this.embed.stop();
	    } else {
	      cov_1wba2voqbv.b[16][1]++;
	    }
	  };

	  _proto.timeUpdate = function timeUpdate(seconds) {
	    cov_1wba2voqbv.f[20]++;
	    cov_1wba2voqbv.s[59]++;

	    if (this.embed) {
	      cov_1wba2voqbv.b[17][0]++;
	      cov_1wba2voqbv.s[60]++;
	      this.embed.timeUpdate(seconds);
	    } else {
	      cov_1wba2voqbv.b[17][1]++;
	    }
	  };

	  return Ptv;
	}(Plugin);

	cov_1wba2voqbv.s[61]++;
	Ptv.defaultState = defaultState;
	cov_1wba2voqbv.s[62]++;
	Ptv.VERSION = version;
	cov_1wba2voqbv.s[63]++;
	videojs__default['default'].registerPlugin('ptv', Ptv);
	var PtvTypes = (cov_1wba2voqbv.s[64]++, window_1.PtvTypes = {
	  ApiHosts: ApiHosts,
	  EmbedHosts: EmbedHosts,
	  PlatformNames: PlatformNames,
	  PlatformTypes: PlatformTypes
	});

	var config$1 = {
	  // Test channel and stream
	  apiHost: ApiHosts.PRODUCTION,
	  embedHost: iframeMarkup,
	  channelId: '5c701be7dc3d20080e4092f4',
	  streamId: '5de7e7c2a6adde5211684519',
	  debug: true
	};

	var configWithDataUrl = _extends_1({}, config$1, {
	  embedHost: 'data:text/html;charset=utf-8,' + encodeURIComponent(iframeMarkup)
	});

	var reParam = function reParam(key, value) {
	  return new RegExp("\\?.*&" + key + "=" + value + "(&|$)");
	};

	var Player = videojs__default['default'].getComponent('Player');
	QUnit__default['default'].test('the environment is sane', function (assert) {
	  assert.strictEqual(typeof Array.isArray, 'function', 'es5 exists');
	  assert.strictEqual(typeof sinon__default['default'], 'object', 'sinon exists');
	  assert.strictEqual(typeof videojs__default['default'], 'function', 'videojs exists');
	  assert.strictEqual(typeof Ptv, 'function', 'plugin is a function');
	});

	var setupPlugin = function setupPlugin() {
	  var _this = this;

	  return new Promise(function (resolve, _) {
	    _this.fixture = document_1.getElementById('qunit-fixture');
	    _this.video = document_1.createElement('video');

	    _this.fixture.appendChild(_this.video);

	    _this.player = videojs__default['default'](_this.video);
	    _this.ptv = _this.player.ptv(configWithDataUrl);

	    _this.player.ready(function () {
	      return resolve();
	    });
	  });
	};

	var teardownPlugin = function teardownPlugin() {
	  var _this2 = this;

	  return new Promise(function (resolve, _) {
	    _this2.ptv.dispose();

	    setTimeout(function () {
	      return resolve();
	    }, 1);
	  });
	};

	QUnit__default['default'].module('videojs-ptv', function (hooks) {
	  hooks.beforeEach(setupPlugin);
	  hooks.afterEach(teardownPlugin);
	  QUnit__default['default'].test('registers itself with video.js', function (assert) {
	    // console.log('this', this);
	    assert.strictEqual(typeof Player.prototype.ptv, 'function', 'videojs-ptv plugin was registered');
	    assert.ok(this.player.hasClass('vjs-ptv'), 'the plugin adds a class to the player');
	  });
	  QUnit__default['default'].test('creates the embed', function (assert) {
	    var iframe = this.fixture.querySelector('iframe.ptv-iframe');
	    assert.strictEqual(iframe, this.ptv.embed.el_, 'creates plugin\'s embed');
	    assert.ok(iframe, 'adds embed to DOM');
	  });
	  QUnit__default['default'].test('applies configuration to iframe URL params', function (assert) {
	    var iframe = this.fixture.querySelector('iframe.ptv-iframe');
	    assert.ok(iframe.src.startsWith("https://" + configWithDataUrl.embedHost), "loads from config.embedHost = " + configWithDataUrl.embedHost);
	    assert.ok(reParam('apiHost', config$1.apiHost), "uses config.apiHost = " + config$1.apiHost);
	    assert.ok(reParam('channelId', config$1.channelId).test(iframe.src), "uses config.channelId = " + config$1.channelId);
	    assert.ok(reParam('streamId', config$1.streamId).test(iframe.src), "uses config.streamId = " + config$1.streamId);
	    assert.ok(reParam('excludePlayer', true).test(iframe.src), 'uses excludePlayer = true');
	    assert.ok(reParam('iframe', true).test(iframe.src), 'uses iframe = true');
	  });
	});
	QUnit__default['default'].module('preload state', function (hooks) {
	  hooks.beforeEach(setupPlugin);
	  hooks.afterEach(teardownPlugin);
	  QUnit__default['default'].test('ptv.hide()', function (assert) {
	    this.ptv.hide();
	    assert.equal(this.ptv.embed.preloadState_.visible, false);
	  });
	  QUnit__default['default'].test('ptv.load() call is added to state if SDK is not ready', function (assert) {
	    this.ptv.load('url');
	    assert.equal(this.ptv.embed.preloadState_.config, 'url');
	  });
	  QUnit__default['default'].test('ptv.show() call is added to state if SDK is not ready', function (assert) {
	    this.ptv.show();
	    assert.equal(this.ptv.embed.preloadState_.visible, true);
	  });
	  QUnit__default['default'].test('ptv.start() call is added to state if SDK is not ready', function (assert) {
	    this.ptv.start();
	    assert.equal(this.ptv.embed.preloadState_.started, true);
	  });
	  QUnit__default['default'].test('ptv.stop() call is added to state if SDK is not ready', function (assert) {
	    this.ptv.stop();
	    assert.equal(this.ptv.embed.preloadState_.started, false);
	  });
	  QUnit__default['default'].test('ptv.timeUpdate() call is added to state if SDK is not ready', function (assert) {
	    this.ptv.timeUpdate(5);
	    assert.equal(this.ptv.embed.preloadState_.time, 5);
	  });
	});
	QUnit__default['default'].module('player events', function (hooks) {
	  hooks.beforeEach(setupPlugin);
	  hooks.afterEach(teardownPlugin);

	  var testFactory = function testFactory(event, apiMethod) {
	    return function (assert) {
	      var spy = sinon__default['default'].spy(this.ptv, apiMethod);
	      this.player.trigger(event);
	      assert.ok(spy.calledOnce, 'api called');
	      this.player.trigger(event);
	      assert.ok(spy.calledTwice, 'api called twice');
	    };
	  };

	  QUnit__default['default'].test('play starts plugin only once', function (assert) {
	    var spy = sinon__default['default'].spy(this.ptv, 'start');
	    this.player.trigger(PlayerEvents.PLAYING);
	    assert.ok(spy.calledOnce, 'api called');
	    this.player.trigger(PlayerEvents.PLAYING);
	    assert.ok(spy.calledOnce, 'api called only once');
	  });
	  QUnit__default['default'].test('play shows plugin', testFactory(PlayerEvents.PLAY, 'show'));
	  QUnit__default['default'].test('ended stops plugin', testFactory(PlayerEvents.ENDED, 'stop'));
	  QUnit__default['default'].test('error stops plugin', testFactory(PlayerEvents.ERROR, 'stop'));
	  QUnit__default['default'].test('pause hides plugin', testFactory(PlayerEvents.PAUSE, 'hide'));
	  QUnit__default['default'].test('time update notifies plugin', testFactory(PlayerEvents.TIME_UPDATE, 'timeUpdate'));
	});
	QUnit__default['default'].module('plugin state', function (hooks) {
	  var origin = 'https://' + configWithDataUrl.embedHost; // The message that we would expect to receive from iframe SDK when it has
	  // loaded the config

	  var mockConfigReadyMessage = {
	    data: JSON.stringify({
	      type: SdkEvents.CONFIG_READY,
	      data: {
	        poster: {
	          loading: ''
	        },
	        src: '',
	        type: ''
	      }
	    }),
	    origin: origin
	  }; // The message that we would expect to receive from iframe SDK when it has
	  // failed to the load the config

	  var mockConfigFailMessage = {
	    data: JSON.stringify({
	      type: SdkEvents.CONFIG_FAILURE
	    }),
	    origin: origin
	  };
	  hooks.beforeEach(setupPlugin);
	  hooks.afterEach(teardownPlugin);
	  QUnit__default['default'].test('config ready', function (assert) {
	    this.ptv.embed.handleMessage_(mockConfigReadyMessage);
	    assert.equal(this.ptv.state.configReady, true, 'configReady = true');
	    assert.equal(this.ptv.state.configFailure, false, 'configFailure = false');
	  });
	  QUnit__default['default'].test('config failure', function (assert) {
	    this.ptv.embed.handleMessage_(mockConfigFailMessage);
	    assert.equal(this.ptv.state.configReady, false, 'configReady = false');
	    assert.equal(this.ptv.state.configFailure, true, 'configFailure = true');
	  });
	});

}(QUnit, videojs, sinon));
